/************************************************************************************************
CENTRALINA T/RH/CLOCK

Permette di gestire 4 rele in funzione
di temperatura, umidit e orario

Le tre condizioni sono messe a OR;  
 se almeno una di queste voci (T/RH/CLOCK)
 dice di attivare il rele, il rele verr attivato.
 
L'impostazione della soglia T e RH  in comune per tutte le prese, non si possono quindi impostare soglie per ogni presa
 
Nel programma si fa rimerimeno a prese e rele ma sono considerati il medesimo oggetto.
 
Precisione della centralina nel commutare in base a T/RH/CLOCK: 
 - T: + o - 1C
 - RH + o - 1%
 - OROLOGIO step di 10 minuti 
 
Compilato con CCS v.4.123 
Uso risorse: circa 61% di ram e 70% di rom.
 Modificando il programma per gestire 6 prese, l'utilizzo di ram arriva al 91% circa
 
 
Autore: Manzoni Giovanni, Hardelettrosoft
Rilasciato con licenza GNU GPL
 
  -> Segui lo sviluppo su http://forum.hardelettrosoft.com/viewforum.php?f=13
 
************************************************************************************************/


#include <18F45K22.h>
#device HIGH_INTS=TRUE
#include <stdlib.h>  
#fuses  MCLR,NODEBUG,NOWDT, NOLVP, NOBROWNOUT, NOPROTECT,INTRC_IO,NOPBADEN
#use delay(clock=8000000) // interno !
#priority ext,rb

#define lcd_v3
#define LCD_DATA_PORT getenv("SFR:PORTA")
#include "lcd_v3.C"


#include "library_date_time.c"
#include "eeprom.c"  
#include "micro_pin.h"
#include "menu_costanti.h"
#include "menu_tree.c"
#include "var.c"
#include "ds1302_mod.c"  

#include "sensore.c"
#include "menu_frasi.c"
#include "menu.c"   
#include "rele.c"
#include "init.c"
#include "menu_engigne.c"   
#include "engigne.c"   


void main();


#zero_ram
void main (){
  
   init();
   for(;;){
   
/*-------------------      
       Menu
-------------------*/   
//continua a scorrerlo, aggiornando le schermate, senza fermarsi in nessun punto

      en_MENU();                        //              >>> MENU <<<

/*-------------------      
   Esecuzione task
-------------------*/
      
      dec_sec--;//  delay_ms(10); * dec_sec=50; = 0.5s
      delay_ms(10);
      if (dec_sec==0){
         dec_sec=50;//reload timer
         
         rtc_read_hour();               //           >>> READ RTC  <<<
         rtc_read_date();
         
		 
		 // Abilitate en_RH() & en_T() & en_CLOCK() 
		 //  solo se si usa il la gestione orologio in mode 2, 
		 //  assegnando tutti i valori ad ogni step di 10 minuti della giornata
		 
         en_RH();              
         
         en_T();               
         
		 en_CLOCK();             
         
         en_prese(); //mette a OR le impostazioni di t/rh/clock
         
         en_MENU_SCREEN_ATTIVO();       
      } 
   }
}
   





     


