/*****************************

	engigne.c

Rilasciato con licenza GNU GPL
	
******************************/

void ee_write_date(int day, int mth, int yy);
int ee_get_day();
int ee_get_mth();
int ee_get_yy();


//locazioni della eeprom da usare
#define EE_LOC_DAY   0
#define EE_LOC_MTH   1
#define EE_LOC_YY   2

/*
Funzione: void ee_write_date(int day, int mth, int yy)
Scopo: Salva in eeprom la data
Ritorna: -
Parametri: 
	int day, int mth, int yy: parametri della data da salvare
Revisione: 1
Note: -
*/ 
void ee_write_date(int day, int mth, int yy){
   write_eeprom(EE_LOC_DAY ,day) ;
   write_eeprom(EE_LOC_MTH,MTH ) ;
   write_eeprom(EE_LOC_YY,yy ) ;
}

/*
Funzione: int ee_get_day()
Scopo: Legge da eeprom il giorno
Ritorna: int il giorno
Parametri: -
Revisione: 1
Note: -
*/ 
int ee_get_day(){
   return read_eeprom(EE_LOC_DAY ) ;
}

/*
Funzione: int ee_get_mth()
Scopo: Legge da eeprom il mese
Ritorna: int il mese
Parametri: -
Revisione: 1
Note: -
*/ 
int ee_get_mth(){
   return read_eeprom(EE_LOC_MTH ) ;
}

/*
Funzione: int ee_get_yy()
Scopo: Legge da eeprom l'anno
Ritorna: int i 'anno
Parametri: -
Revisione: 1
Note: -
*/ 
int ee_get_yy(){
   return read_eeprom(EE_LOC_YY ) ;
}




