/*****************************

	engigne.c

Rilasciato con licenza GNU GPL
	
******************************/
 
void en_CLOCK();
void en_RH();
void en_T();
void en_prese();


/*

//**************************************************
//
//  COMMUTAZIONE DELLE PRESE IN MODO DIRETTO
//
//**************************************************


void en_CLOCK(){ 
   int z,j,step_minuto;
   if(orologio_mode!=MODE_NO){
      // calcolo indice x i minuti  
      //  in modo che se si esce dalla soglia di errore di t o rh, il sistema riprende a seguire l'orologio.
   
      // controlla match ora e minuti di ON e di OFF con finestra di 10 minuti
           if ((rtc.mm> 0) && (rtc.mm<10)) j=0;
      else if ((rtc.mm> 9) && (rtc.mm<20)) j=1;
      else if ((rtc.mm>19) && (rtc.mm<30)) j=2;
      else if ((rtc.mm>29) && (rtc.mm<40)) j=3;
      else if ((rtc.mm>39) && (rtc.mm<49)) j=4;
      else if (rtc.mm>49) j=5;
      step_minuto=j*10;
      
     if(orologio_mode==MODE1){// mode 1 on-off
         // scansiona prese
         for(z=0;z<PRESE_QTY;z++){
            if(presa[z].global_pass==TRUE){ // SE ORA VALIDA
              if((presa[z].on_hh== rtc.hh) &&(presa[z].on_mm== step_minuto)) presa_set(z,ON); // imposta lo stato della presa
              else if((presa[z].off_hh== rtc.hh) &&(presa[z].off_mm== step_minuto)) presa_set(z,OFF); // imposta lo stato della presa
            }  
         } 
      } 
    else if (orologio_mode==MODE2){ // mode 2 on-off in passi di 10 minuti
         // il controllo sopra  ridondante ma  meglio metterlo
         // imposta stato della presa z in base all'orario attuale.
         // se la presa non deve cambiare stato, il suo stato rimane invariato.
            for(z=0;z<PRESE_QTY;z++){                    // per ogni presa
              if(presa[z].Timer[rtc.hh][j]!= P_X)        //se  stato impostato uno stato
                  presa_set(z,presa[z].Timer[rtc.hh][j]);//imposta lo stato impostato in ram per tale presa per l'orario corrente
              //else rimane invariato
            }
      } 
   }
}
 
void en_RH(){ 
   int z;
   
   //TO DO: if rh enabled
   if ((RHmin.valido==SI) && (RHmax.valido==SI)){
      for(z=0;z<PRESE_QTY;z++){                    // per ogni presa
         //   se rh_sensore (=rh_int) < rhmin 
         //      se per qll presa c un valore da usare
         //         allora imposta la presa
         //   se rh_sensore (=rh_int) > rhmax
         //      se per qll presa c un valore da usare
         //         allora imposta la presa
         //   altrimenti la temp  compresa tra tmin e tmax
         //      se per qll presa c un valore da usare
         //         allora imposta la presa
         
         if(rh_int < RHmin.valore){           // se rh_sensore (=rh_int) < rhmin 
           if(presa[z].RHmin!= P_X)           //  se per qll presa c un valore da usare
               presa_set(z,presa[z].RHmin);   //   allora imposta la presa
         }
         else if(rh_int > RHmax.valore){      // se rh_sensore (=rh_int) < rhmin 
           if(presa[z].RHmax!= P_X)           //  se per qll presa c un valore da usare
               presa_set(z,presa[z].RHmax);   //   allora imposta la presa
         }
         else {                               // se rh_sensore (=rh_int) COMPRESO
           if(presa[z].RHcomp!= P_X)          //  se per qll presa c un valore da usare
               presa_set(z,presa[z].RHcomp);  //   allora imposta la presa 
         }
      }
   }
}

void en_T(){ 
   int z;
   //TO DO: if t enabled
   if ((Tmin.valido==SI) && (Tmax.valido==SI)){
      for(z=0;z<PRESE_QTY;z++){                    // per ogni presa
         //   se t_sensore (=t_int) < tmin 
         //      se per qll presa c un valore da usare
         //         allora imposta la presa
         //   se t_sensore (=t_int) > tmax
         //      se per qll presa c un valore da usare
         //         allora imposta la presa
         //   altrimenti la temp  compresa tra tmin e tmax
         //      se per qll presa c un valore da usare
         //         allora imposta la presa
         
         if(t_int < Tmin.valore){           // se temperatura del sensore (=t_int) < tmin 
           if(presa[z].Tmin!= P_X)           //  se per qll presa c un valore da usare
               presa_set(z,presa[z].Tmin);   //   allora imposta la presa
         }
         else if(t_int > Tmax.valore){      // se temperatura del sensore (=t_int) < tmin 
           if(presa[z].Tmax!= P_X)           //  se per qll presa c un valore da usare
               presa_set(z,presa[z].Tmax);   //   allora imposta la presa
         }
         else {                               // se temperatura del sensore (=t_int) COMPRESO
           if(presa[z].Tcomp!= P_X)          //  se per qll presa c un valore da usare
               presa_set(z,presa[z].Tcomp);  //   allora imposta la presa 
         }
      }
   }
}
*/



//**************************************************
//
// COMMUTAZIONE DELLE PRESE TRAMITE OR SU VARIABILI
//
//**************************************************

/*
Funzione: void en_CLOCK()
Scopo: Gestice lo stato delle prese in base all'orario
Ritorna: -
Parametri: 
Revisione: 2.1
Note: -
*/   
void en_CLOCK(){ 
   int z,j,step_minuto;
   if(orologio_mode!=MODE_NO){
      // calcolo indice x i minuti  
      //  in modo che se si esce dalla soglia di errore di t o rh, il sistema riprende a seguire l'orologio.
   
      // controlla match ora e minuti di ON e di OFF con finestra di 10 minuti
           if ((rtc.mm> 0) && (rtc.mm<10)) j=0;
      else if ((rtc.mm> 9) && (rtc.mm<20)) j=1;
      else if ((rtc.mm>19) && (rtc.mm<30)) j=2;
      else if ((rtc.mm>29) && (rtc.mm<40)) j=3;
      else if ((rtc.mm>39) && (rtc.mm<49)) j=4;
      else if (rtc.mm>49) j=5;
      step_minuto=j*10;
      
     if(orologio_mode==MODE1){// mode 1 on-off
         // scansiona prese
         for(z=0;z<PRESE_QTY;z++){
            if(presa[z].global_pass==TRUE){ // SE ORA VALIDA
              if((presa[z].on_hh== rtc.hh) &&(presa[z].on_mm== step_minuto)) bit_set(p_clock,z);//presa_set(z,ON); // imposta lo stato della presa
              else if((presa[z].off_hh== rtc.hh) &&(presa[z].off_mm== step_minuto)) bit_clear(p_clock,z);//presa_set(z,OFF); // imposta lo stato della presa
            }  
         } 
      } 
    else if (orologio_mode==MODE2){ // mode 2 on-off in passi di 10 minuti
         // il controllo sopra  ridondante ma  meglio metterlo
         // imposta stato della presa z in base all'orario attuale.
         // se la presa non deve cambiare stato, il suo stato rimane invariato.
            for(z=0;z<PRESE_QTY;z++){                    // per ogni presa
              if(presa[z].Timer[rtc.hh][j]== P_ON) bit_set(p_clock,z);
			  else if(presa[z].Timer[rtc.hh][j]== P_OFF) bit_clear(p_clock,z);
              //else rimane invariato
            }
      } 
   }
}

/*
Funzione: void en_RH()
Scopo: Gestice lo stato delle prese in base all'umidit
Ritorna: -
Parametri: 
Revisione: 3
Note: -
*/   
void en_RH(){ 
   int z;
   
   //TO DO: if rh enabled
   if ((RHmin.valido==SI) && (RHmax.valido==SI)){
      for(z=0;z<PRESE_QTY;z++){                    // per ogni presa
         //   se rh_sensore (=rh_int) < rhmin 
         //      se per qll presa c un valore da usare
         //         allora imposta la presa
         //   se rh_sensore (=rh_int) > rhmax
         //      se per qll presa c un valore da usare
         //         allora imposta la presa
         //   altrimenti la temp  compresa tra tmin e tmax
         //      se per qll presa c un valore da usare
         //         allora imposta la presa
         
         if(rh_int < RHmin.valore){           // se rh_sensore (=rh_int) < rhmin 
           if(presa[z].RHmin== P_ON) bit_set(p_rh,z);
		   else if(presa[z].RHmin== P_OFF) bit_clear(p_rh,z);
		   
         }
         else if(rh_int > RHmax.valore){      // se rh_sensore (=rh_int) < rhmin 
           if(presa[z].RHmax== P_ON)     bit_set(p_rh,z);
		   else if(presa[z].RHmax== P_OFF)    bit_clear(p_rh,z);
		   
         }
         else {                               // se rh_sensore (=rh_int) COMPRESO
           if(presa[z].RHcomp== P_ON) bit_set(p_rh,z);
		   else if(presa[z].RHcomp== P_OFF) bit_clear(p_rh,z);
		   
         }
      }
   }
}

/*
Funzione: void en_T()
Scopo: Gestice lo stato delle prese in base alla temperatura
Ritorna: -
Parametri: 
Revisione: 3
Note: -
*/   
void en_T(){ 
   int z;
   //TO DO: if t enabled
   if ((Tmin.valido==SI) && (Tmax.valido==SI)){
      for(z=0;z<PRESE_QTY;z++){                    // per ogni presa
         //   se t_sensore (=t_int) < tmin 
         //      se per qll presa c un valore da usare
         //         allora imposta la presa
         //   se t_sensore (=t_int) > tmax
         //      se per qll presa c un valore da usare
         //         allora imposta la presa
         //   altrimenti la temp  compresa tra tmin e tmax
         //      se per qll presa c un valore da usare
         //         allora imposta la presa
         
         if(t_int < Tmin.valore){           // se temperatura del sensore (=t_int) < tmin 
           if(presa[z].Tmin== P_ON) bit_set(p_t,z);
           else if(presa[z].Tmin== P_OFF) bit_clear(p_t,z);
         }
         else if(t_int > Tmax.valore){      // se temperatura del sensore (=t_int) < tmin 
           if(presa[z].Tmax== P_ON) bit_set(p_t,z); 
		   else if(presa[z].Tmax== P_OFF) bit_clear(p_t,z); 
		   
         }
         else {                               // se temperatura del sensore (=t_int) COMPRESO
           if(presa[z].Tcomp== P_ON) bit_set(p_t,z);
		   else if(presa[z].Tcomp== P_OFF) bit_clear(p_t,z);
         }
      }
   }
}

/*
Funzione: void en_T()
Scopo: Gestice lo stato delle prese mettendo a OR temperatura, umidit e orario
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/   
void en_prese(){
	int prese;
	
	prese= p_t | p_rh | p_clock;
	prese = prese & PRESE_MASK;
	output_d(prese);
}



/*

OLD ENGIGNE

Funzione: void en_T()
Scopo: Gestice lo stato delle prese in base a temperatura, umidit e orologio
Ritorna: -
Parametri: 
Revisione: 3
Note: -

void en_prese(){
	int out=0x00;
	int1 on_t,on_rh,on_clock;
	int1 off_t,off_rh,off_clock;
	//int1 nchg_t,nchg_rh,nchg_clock;
	int z,j,step_minuto;
	   
	if(orologio_mode!=MODE_NO){
	  // calcolo indice x i minuti  
	  //  in modo che se si esce dalla soglia di errore di t o rh, il sistema riprende a seguire l'orologio.
   
	  // controlla match ora e minuti di ON e di OFF con finestra di 10 minuti
		   if ((rtc.mm> 0) && (rtc.mm<10)) j=0;
	  else if ((rtc.mm> 9) && (rtc.mm<20)) j=1;
	  else if ((rtc.mm>19) && (rtc.mm<30)) j=2;
	  else if ((rtc.mm>29) && (rtc.mm<40)) j=3;
	  else if ((rtc.mm>39) && (rtc.mm<49)) j=4;
	  else if (rtc.mm>49) j=5;
	  step_minuto=j*10;
	}  
	
	for(z=0;z<PRESE_QTY;z++){    
		on_t=0;on_rh=0;on_clock=0;
		off_t=0;off_rh=0;off_clock=0;
		//nchg_t=0;nchg_rh=0;nchg_clock=0;
		
		
		//T
		if ((Tmin.valido==SI) && (Tmax.valido==SI)){
			if(t_int < Tmin.valore){           // se temperatura del sensore (=t_int) < tmin 
			    if(presa[z].Tmin== P_ON) on_t=1;        
				else if(presa[z].Tmin== P_OFF) off_t=1;        
				//else nchg_t=1; 
			 }
			 else if(t_int > Tmax.valore){      // se temperatura del sensore (=t_int) < tmin 
			   if(presa[z].Tmax== P_ON) on_t=1;         //  se per qll presa c un valore da usare
			   else if(presa[z].Tmax== P_OFF) off_t=1;         //  se per qll presa c un valore da usare
			   //else nchg_t=1;    
			 }
			 else {                               // se temperatura del sensore (=t_int) COMPRESO
			    if(presa[z].Tcomp== P_ON) on_t=1;        
				else if(presa[z].Tcomp== P_OFF) off_t=1;  
				//else nchg_t=1; 				
			 }	
		}
		// solo uno o nessuno tra on_t, off_t e nchg_t sar a 1
		
		
		//RH
		if ((RHmin.valido==SI) && (RHmax.valido==SI)){
			if(rh_int < RHmin.valore){           // se temperatura del sensore (=t_int) < tmin 
			    if(presa[z].RHmin== P_ON) on_rh=1;        
				else if(presa[z].RHmin== P_OFF) off_rh=1;        
				//else nchg_rh=1; 
			 }
			 else if(rh_int > RHmax.valore){      // se temperatura del sensore (=t_int) < tmin 
			   if(presa[z].RHmax== P_ON) on_rh=1;         //  se per qll presa c un valore da usare
			   else if(presa[z].RHmax== P_OFF) off_rh=1;         //  se per qll presa c un valore da usare
			   //else nchg_rh=1;    
			 }
			 else {                               // se temperatura del sensore (=t_int) COMPRESO
			    if(presa[z].RHcomp== P_ON) on_rh=1;        
				else if(presa[z].RHcomp== P_OFF) off_rh=1;  
				//else nchg_rh=1; 				
			 }	
		}
		// solo uno tra on_rh, off_rh e nchg_rh sar a 1
		
		if(orologio_mode!=MODE_NO){
			if(orologio_mode==MODE1){// mode 1 on-off
			 // scansiona prese
				if(presa[z].global_pass==TRUE){ // SE ORA VALIDA
					if((presa[z].on_hh== rtc.hh) &&(presa[z].on_mm== step_minuto)) on_clock=1;
					else if((presa[z].off_hh== rtc.hh) &&(presa[z].off_mm== step_minuto)) off_clock=1;
					//else nchg_clock=1; 
				}  
			} 
			else if (orologio_mode==MODE2){ // mode 2 on-off in passi di 10 minuti
			 // il controllo sopra  ridondante ma  meglio metterlo
			 // imposta stato della presa z in base all'orario attuale.
			 // se la presa non deve cambiare stato, il suo stato rimane invariato.
				   
				if(presa[z].Timer[rtc.hh][j]== P_ON)  on_clock=1;       
				else if(presa[z].Timer[rtc.hh][j]== P_OFF)  off_clock=1;       
				//else nchg_clock=1; 
			} 
		}
	    // solo uno tra on_clock, off_clock e nchg_clock sar a 1
	
		//OR engigne
		// se anche solo un parametro tra t/rh/clock dice di mettere a on l'uscita, l'uscita verr messa a on
		//set ? 
		if ( (on_t==1) || (on_rh==1) || (on_clock==1) ) presa_set(z,1);
		else if ( (off_t==1) || (off_rh==1) || (off_clock==1) ) presa_set(z,0);
		// else not change
	}
}

*/
