/*****************************

	init.c

Rilasciato con licenza GNU GPL
	
******************************/


void init();
void prem_ril();
void prem_ril_pulse_su();

/*
Funzione: void init()
Scopo: Init micro
Ritorna: -
Parametri: -
Revisione: 1
Note: -
*/ 
void init(){             
int i,j,k;    
// hw micro
   setup_oscillator(OSC_8MHZ);
   SETUP_CCP1(CCP_OFF);
   SETUP_SPI(SPI_DISABLED);
   SETUP_ADC(ADC_CLOCK_INTERNAL);
   SETUP_ADC_PORTS(NO_ANALOGS);
   output_a(0x00);
   output_b(0x00);
   output_c(0x00);
   output_d(0x00);
   output_e(0x00);
   k=input(pag_su);
   k=input(pag_giu);
   k=input(pag_dx);
   k=input(pag_sx);
   k=input(pag_set);
   k=input(SENS_CLK);
   k=input(SENS_DATA);
   k=input(RTC_IO);
  
  
   enable_interrupts(int_rb);    // abilita pulsanti
   ext_int_edge(H_TO_L);         // IN INTERRUPT ALLA PRESSIONE
   enable_interrupts(int_ext);   // abilita pulsanti
   
  
//hw esterno
   output_low(allarme); 
   delay_ms(200);// stabilizazione alimanteazione
   
   //RTC
   rtc_init();
   rtc_read_hour();
   rtc_read_date();
     
   //eeprom
   i=ee_get_day();
   j=ee_get_mth();
   k=ee_get_yy();
   if ((i==255) || (j==255) || (k==255) ){
      ee_write_date(rtc.day,rtc.mth,rtc.yy);
   }
     
   //PRESE 
   rele_init();

   //SENSORE T RH
   SendReset();    //sensore
 
   //LCD
   lcd_init();
   lcd_putc("\fHARDELETTROSOFT\nCent. T/RH/CLOCK");
   delay_ms(5000);

   //VARIABILI PROGRAMMA
   dec_sec=50; // x scansione
   
   OROLOGIO_STEP=MINUTI;
   
   temp_soglia.valido=  NO; 
   temp_soglia.valore=  1 ;                                                                                
   
   RHmin.valido= NO;
   RHmax.valido= NO;
   Tmin.valido=  NO;        
   Tmax.valido=  NO;
   RHmin.valore= SOGLIA_MIN;
   RHmax.valore= SOGLIA_MAX;
   Tmin.valore=  SOGLIA_MIN;        
   Tmax.valore=  SOGLIA_MAX;
   
   orologio_mode=MODE_NO;
  
   temp_presa.off_hh=   0;
   temp_presa.off_mm=   0;
   temp_presa.on_hh=    0; 
   temp_presa.on_mm=    0; 
   temp_presa.global_pass=NO;//orario non valido
   temp_presa.RHmin=    P_X;  // stato in cui si deve portare la presa una volta valicata la soglia
   temp_presa.RHmax=    P_X;
   temp_presa.RHcomp=   P_X;
   temp_presa.Tmax=     P_X;
   temp_presa.Tmin=     P_X;
   temp_presa.Tcomp=    P_X;
   
   
   for(j=0;j<24;j++) {//ora da 0 a 23 
    for(k=0;k<6;k++) //minuto da 0 a 5                                                                   
       temp_presa.Timer[j][k]=P_X;
   }                     
   for(j=0;j<PRESE_QTY;j++) presa[j]=temp_presa;
             

	p_clock=0;
	p_t=0;
	p_rh=0;

   //pulsanti
   p_valido=NESSUNO;
   lev=NULL; 
   lev.L_0=SI;
   screen_attivo=DATI;
   pag=screen_attivo;
   lcd_menu(0);        // imposta primo menu
      
      
  //ora pu abilitare interrupt
  enable_interrupts(GLOBAL);   // abilita pulsanti
  
}


/**********************

GESTIONE PULSANTI

**********************/

/*
Funzione: void prem_ril()
Scopo: Gestisce pulsanti GIU DX SX SET su interrupt
Ritorna: -
Parametri: -
Revisione: 1
Note: -
*/ 
#int_rb
void prem_ril(){

   static int pulsante;// pulsante premuto

   //imposto il pulsante premuto cosi al prossimo cambiamento di portb, 
   // confermo la pressione e il rilascio del pulsante.
   
   // setta quale pulsante  stato premuto
   
   if (input(pag_giu)==PREMUTO){ pulsante=GIU;  output_high(LED_CPU);   }
   else if (input(pag_dx) ==PREMUTO){ pulsante=DX;   output_high(LED_CPU);  }
   else if (input(pag_sx) ==PREMUTO){ pulsante=SX;  output_high(LED_CPU);   }
   else if (input(pag_set)==PREMUTO){ pulsante=SET;  output_high(LED_CPU);  }

   else{
//allora il pulsante  stato rilasciato !!
// controlla se il pulsante rilasciato  quello premuto
// altrimenti si tratta di una pressione di + pulsanti ed  da annullare

      p_valido=pulsante;
      pulsante=NESSUNO;
      output_low(LED_CPU);
   }
   
}

/*
Funzione: void prem_ril_pulse_su()
Scopo: Gestisce pulsante 'SU' su interrupt
Ritorna: -
Parametri: -
Revisione: 1
Note: -
*/ 
#int_EXT
void prem_ril_pulse_su(){
  
   if (input(pag_su)==PREMUTO){      // se in interrupt x fronte da alto a basso 
      ext_int_edge(L_TO_H);         // impostaprox interrupt sul rilascio
      output_high(LED_CPU);
   }
   else{                            // pulsante rilasciato
      ext_int_edge(H_TO_L);         // sistema interrupt x prossima occorrenza
      p_valido=SU;                  // il pulsante su  quello rilasciato   
      output_low(LED_CPU);
   }
} 
                                                   


