/*****************************

	menu.c

Rilasciato con licenza GNU GPL
	
******************************/
void lcd_selez_minuti();
void lcd_selez_ore();
void lcd_selez_orologio_canc();
void lcd_selez_day();
void lcd_selez_mth();
void lcd_selez_yy();
void lcd_selez_data_canc();
int hh_get();
int mm_get();
void lcd_orologio_step_calc();
int1 lcd_orologio_scorri();
void lcd_azione_presa();
int1 lcd_setup_hour();
int1 lcd_setup_date();
void lcd_menu(int livello,int sottomenu=0);
void menu_scorri(int livello,int sottomenu=0);


/*
Funzione: void lcd_selez_minuti()
Scopo: Disegna le frecce di selezione
Ritorna: -
Parametri: -
Revisione: 1
Note: 
*/ 
void lcd_selez_minuti(){   //usato solo per prese  
   lcd_gotoxy(9,1);         
   lcd_putc(" "); // cancella
   lcd_gotoxy(15,1);
   lcd_putc("<");        

}

/*
Funzione: void lcd_selez_ore()
Scopo: Disegna le frecce di selezione
Ritorna: -
Parametri: -
Revisione: 1
Note: 
*/ 
void lcd_selez_ore(){
   lcd_gotoxy(15,1);
   lcd_putc(" "); // cancella
   lcd_gotoxy(9,1);
   lcd_putc(">");        
}

/*
Funzione: void lcd_selez_orologio_canc()
Scopo: Pulisce lo schermo
Ritorna: -
Parametri: -
Revisione: 1
Note: 
*/ 
void lcd_selez_orologio_canc(){
      lcd_gotoxy(9,1);
      lcd_putc(" "); // cancella
      lcd_gotoxy(15,1);
      lcd_putc(" ");        
}

/*
Funzione: void lcd_selez_day()
Scopo: Disegna frecce di selezione
Ritorna: -
Parametri: -
Revisione: 1
Note: 
*/ 
void lcd_selez_day(){
   lcd_gotoxy(14,1); //yy
   lcd_putc(" "); 
   lcd_gotoxy(10,1); //mth
   lcd_putc(" ");   
   lcd_gotoxy(6,1); //day
   lcd_putc(">");   
   
}

/*
Funzione: void lcd_selez_mth()
Scopo: Disegna frecce di selezione
Ritorna: -
Parametri: -
Revisione: 1
Note: 
*/  
void lcd_selez_mth(){
   lcd_gotoxy(14,1); //yy
   lcd_putc(" "); 
   lcd_gotoxy(6,1); //day
   lcd_putc(" ");   
   lcd_gotoxy(10,1); //mth
   lcd_putc(">");   
   
}

/*
Funzione: void lcd_selez_yy()
Scopo: Disegna frecce di selezione
Ritorna: -
Parametri: -
Revisione: 1
Note: 
*/  
void lcd_selez_yy(){
   lcd_gotoxy(10,1); //mth
   lcd_putc(" "); 
   lcd_gotoxy(6,1); //day
   lcd_putc(" ");   
   lcd_gotoxy(14,1); //yy
   lcd_putc(">"); 
}

/*
Funzione: void lcd_selez_data_canc()
Scopo: Pulisce lo schermo
Ritorna: -
Parametri: -
Revisione: 1
Note: 
*/   
void lcd_selez_data_canc(){
   lcd_gotoxy(10,1); //mth
   lcd_putc(" "); 
   lcd_gotoxy(6,1); //day
   lcd_putc(" ");   
   lcd_gotoxy(14,1); //yy
   lcd_putc(" ");       
}

/*
Funzione: int hh_get()
Scopo: Calcola l'ora dell'orologio in base alla pagina in cui ci si trova
Ritorna: int, ora in base alla pagina in cui ci si trova
Parametri: -
Revisione: 1.1
Note: Chiamare mm_get sempre dopo hh_get()
*/   
int hh_get() {
   int temp,hh;                      
   hh=0;
   temp=pag;   
           
   while (temp>6){ // 6 x 10min = 1 ora
      temp=temp-6;    
      hh++;      
   }
   return hh;
}                                                                

/*
Funzione: int mm_get()
Scopo: Calcola i minuti dell'orologio in base alla pagina in cui ci si trova
Ritorna: 0..6 in base allo step di iminuti in cui ci si trova
Parametri: -
Revisione: 1.1
Note: Chiamare mm_get sempre dopo hh_get()
*/   
int mm_get(){  // 
   int temp;                                                                                   
   temp=pag;   
   while (temp>6){ // 6 passi  da 10 minuti                    
      temp=temp-6;    
   }
   if      (temp==0) {lcd_putc("\f err 0mm"); return 0;}
   else if (temp==1) return 0;
   else if (temp==2) return 10;
   else if (temp==3) return 20;
   else if (temp==4) return 30;
   else if (temp==5) return 40;
   else if (temp==6) return 50;
   else lcd_putc("\ferr 60mm"); //dbg    
}
  
/*
Funzione: void lcd_orologio_step_calc()
Scopo: Ricavo l'ra da mostrare in base allo step corrente
Ritorna: -
Parametri: -
Revisione: 1
Note:	
*/   
void lcd_orologio_step_calc(){ 
   hh_scelta=hh_get();
   mm_scelta=mm_get();
                                                  
   // mostro i valori
   lcd_gotoxy(10,1);//,2
   scrivi_num(hh_scelta,ZERO); 
   lcd_putc(":");                                      
   scrivi_num(mm_scelta,ZERO); // la funzione ritorna gli inici x array non il passo in 10 minuti !!!
}  
 
/*
Funzione: int1 lcd_orologio_scorri()
Scopo: Gestisce l'incremento di ore e minuti nel setup dell'orologio
Ritorna: int1 se l'ora  stata cambiata
Parametri: -
Revisione: 1
Note: Funzione usata per le prese
*/ 
int1 lcd_orologio_scorri(){ 
   static int1 fixato=TRUE;
   
   // controlla se cambiare l'avanzamento x minuti o per ore
   if (p_valido==DX){ // scorrimento schermata down
      p_valido=NESSUNO;
      orologio_step=MINUTI; 
      lcd_selez_minuti(); // disegna freccia
   }
   else if (p_valido==SX){  // scorrimento schermata up
      p_valido=NESSUNO;
      orologio_step=ORE;                             
      lcd_selez_ore(); // disegna freccia
   }
   else if (p_valido==SU){ // INCREMENTA
      p_valido=NESSUNO;
      if (presa_opz==OFF )temp_presa.off_pass=SI; // vera di default, se invalida, viene sistemata
      else temp_presa.on_pass=SI;           // vera di default, se invalida, viene sistemata
      
   // TODO: controllare se sta premuto x + tempo x avanzare di ora in ora
TEST1:               
      if(orologio_step==MINUTI){
         if (pag<pag_limit) {    
            if (fixato==FALSE){
               fixato=TRUE;
               pag=1; // va x forza 1 cosi quando clicco in giu passa a 01:00. se fosse pag=0, diventerebbe 00:50
               
               lcd_gotoxy(8,1);//,2 -> 10 ?
               lcd_orologio_step_calc();
               return FALSE;
            }        
            else pag++;
         }
      }                  
      else{ // ore    
         if ((pag+6)<pag_limit){ 
            pag=pag+6;
         }                                                            
         else{
            // orario tra 23:00 e 23:50
            lcd_selez_minuti();
            orologio_step=MINUTI; 
            
            goto TEST1; // vede se pu incrementare la pagina dei minuti
         }
      }   
      return TRUE;      
   }
   else if (p_valido==GIU){  // DECREMENTA
      p_valido=NESSUNO;
      if (presa_opz==OFF ) temp_presa.off_pass=SI; // vera di default, se invalida, viene sistemata
      else           temp_presa.on_pass=SI; // vera di default, se invalida, viene sistemata
   
      //TODO: controllare se sta premuto x + tempo x avanzare di ora in ora
STEP2:
      if(orologio_step==MINUTI){
         if(orologio_mode==MODE1){// mode 1 on-off alle xx:xx
            if (pag<2){ // pag ==1 o 0.PAG= = ??:??
               pag=1; // va x forza 1 cosi quando clicco in giu passa a 01:00. se fosse pag=0, diventerebbe 00:50
               hh_scelta=0;
               mm_scelta=0;
               fixato=FALSE;
               lcd_gotoxy(10,1); //,2
               lcd_putc("??:??"); // si, orario invalido
               
               if (presa_opz==OFF )temp_presa.off_pass=NO; // vera di default, se invalida, viene sistemata
               else temp_presa.on_pass=NO; // vera di default, se invalida, viene sistemata
               
               return FALSE;
            }
            else{ // orario tra 00:10 e 23:50
               pag--; // no, c'era almeno uno step di minuti, lo decremento
            }
         }
         else if(pag>1){ // orario tra 00:10 e 23:50
               pag--; // no, c'era almeno uno step di minuti, lo decremento
         }
      }
      else{ // ore                    
         if (pag>6){ // orario tra 01:00 e 23:50
            lcd_selez_ore();            
            pag=pag-6;
         }                                                            
         else{  // orario tra 00:00 e 01:00
            orologio_step=MINUTI; 
            lcd_selez_minuti();
            GOTO step2;
         }
      }   
      return TRUE;
   }
   return FALSE;
}

/*
Funzione: void lcd_azione_presa()
Scopo: Mostra ora e azione in base alla presa scelta
Ritorna: -
Parametri: -
Revisione: 1
Note:	
*/
void lcd_azione_presa(){  // 
   if(pag==L1_3_2_1_LIMITE) lcd_putc("\fEsci");
   else{
      lcd_gotoxy(1,1);
      lcd_putc(" "); // cancella la E di Esci se premo giu e poi su in esci
      lcd_orologio_step_calc(); // calcola hh_scelta e mm_scelta
      lcd_gotoxy(2,1);
      presa_azione(presa[presa_scelta].Timer[hh_scelta][mm_scelta/10]);           
   } 
} 

/*
Funzione: int1 lcd_setup_hour()
Scopo: Permette di impostare l'ora su lcd tramite i pulsanti 
Ritorna: int1 true, se l'ora  stata cambiata
Parametri: -
Revisione: 1
Note:	
*/
int1 lcd_setup_hour(){
   
   if (p_valido==DX){ 
      p_valido=NESSUNO;
      orologio_step=MINUTI; 
      lcd_selez_minuti(); // disegna freccia
   }
   else if (p_valido==SX){  
      p_valido=NESSUNO;
      orologio_step=ORE;                             
      lcd_selez_ore(); // disegna freccia
   }
   else if (p_valido==SU){ //INCREMENTA
      p_valido=NESSUNO;
      
   // controlla se cambiare l'avanzamento x minuti o per ore
   // TODO: controllare se sta premuto x + tempo x avanzare di ora in ora tenendo premuto il pulsante
TEST1:               
      if(orologio_step==MINUTI){
         if (setup.mm<59)  setup.mm = setup.mm+1;        
         else if (setup.hh<23){
            setup.mm=0;
            setup.hh=setup.hh+1;
         }
      }
      else if (setup.hh<23)   setup.hh=setup.hh+1; // Ore
      else{ // hh= 23:xx
         orologio_step=MINUTI;
         lcd_selez_minuti(); // disegna freccia
         goto TEST1;
      }
      return true;
   }
   else if (p_valido==GIU){ //DECREMENTA
      p_valido=NESSUNO;
   
      // controllare se sta premuto x + tempo x avanzare di ora in ora
STEP2:
      if(orologio_step==MINUTI){
         if (setup.mm>0)  setup.mm = setup.mm-1;        
         else if (setup.hh>0){
            setup.mm=59;
            setup.hh=setup.hh-1;
         }
      }
      else{ // ore
         if (setup.hh>0){ // orario tra 01:00 e 23:50
            lcd_selez_ore();            
            setup.hh=setup.hh-1;
         }                                                            
         else{  // orario tra 00:00 e 01:00
            orologio_step=MINUTI; 
            lcd_selez_minuti();
            GOTO step2;
         }
      }   
      return true;
   }
   return false;
}  

/*
Funzione: int1 lcd_setup_date()
Scopo: Permette di impostare la data su lcd tramite i pulsanti 
Ritorna: int1 true, se l'ora  stata cambiata
Parametri: -
Revisione: 1
Note:	
*/
int1 lcd_setup_date(){

   // controlla se cambiare l'avanzamento x minuti o per ore

   if (p_valido==DX){ 
      p_valido=NESSUNO;
      
      //STEP_DD STEP_MTH STEP_YY 
      if(data_step==STEP_DD){
         data_step=STEP_MTH;
         lcd_selez_mth(); // disegna freccia
      }
      else if(data_step==STEP_MTH){
         data_step=STEP_YY;
         lcd_selez_yy(); // disegna freccia
      }
   }
   else if (p_valido==SX){  
      p_valido=NESSUNO;
      //STEP_DD STEP_MTH STEP_YY 
     
      if(data_step==STEP_MTH){
         data_step=STEP_DD;
         lcd_selez_day(); // disegna freccia
      }
      else if(data_step==STEP_YY){
         data_step=STEP_MTH;
         lcd_selez_mth(); // disegna freccia
      }
   }
   else if (p_valido==SU){ //INCREMENTA
      p_valido=NESSUNO;
      
   // controllare se sta premuto x + tempo x avanzare di ora in ora tenendo premuto il pulsante
TEST1:               
      if(data_step==STEP_DD){
         lcd_selez_day();
         if (setup.day<31){           // day<31 mth=? yy=?
            setup.day = setup.day+1;
         }
         else if (setup.mth<12){     // day=31 mth<12 yy=?
            setup.day=1;
            setup.mth=setup.mth+1;
         }
         else if( setup.yy<99){      // day=31, mth=12 yy<99
            setup.day=1;
            setup.mth=1;
            setup.yy=setup.yy+1;
         }
      }
      else if(data_step==STEP_MTH){
         lcd_selez_mth();
         if (setup.mth<12){          // day=?, mth<12 yy=? 
            setup.mth=setup.mth+1;
         }
         else if( setup.yy<99){      // day=?, mth=12 yy<99
            setup.mth=1;
            setup.yy=setup.yy+1;
         }
      }   
      else if(data_step==STEP_YY){ 
         lcd_selez_yy(); 
         if (setup.yy<99){           // day=?, mth=z yy>1
            setup.yy=setup.yy+1;
         }
      }   
      return true;
   }
   else if (p_valido==GIU){  //DECREMENTA
      p_valido=NESSUNO;
   
      // TODO: controllare se sta premuto x + tempo x avanzare di ora in ora
STEP2:
      if(data_step==STEP_DD){
         lcd_selez_day();
         if (setup.day>1){          // day>1 mth=? yy=?
            setup.day = setup.day-1;  // >>>> se si tocca il valore di setup.xx -> prima va aggiornata la freccia davanti a questo numero
         }
         else if (setup.mth>1){     // day=1 mth>1 yy=?
            setup.day=31;
            setup.mth=setup.mth-1;
         }
         else if( setup.yy>0){      // day=1, mth=1 yy>0
            setup.day=31;
            setup.mth=12;
            setup.yy=setup.yy-1;
         }
      }
      else if(data_step==STEP_MTH){
         lcd_selez_mth();   
         if (setup.mth>1){          // day=?, mth>1 yy=? 
            setup.mth=setup.mth-1;
         }                                                            
         else if( setup.yy>0){      // day=?, mth=1 yy>1
            setup.mth=12;
            setup.yy=setup.yy-1;
         }
      }  
      else if(data_step==STEP_YY){ 
         lcd_selez_yy(); 
         if (setup.yy>0){           // day=?, mth=z yy>1
            setup.yy=setup.yy-1;
         }
      }   
      return true;
   }
   return false;
}  



/********************

VOCI MENU

********************/
/*
Funzione: void lcd_menu(int livello,int sottomenu=0)
Scopo: Mostra sul display le scermate dei vari menu
Ritorna: -
Parametri:
	livello: livelo del menu
	sottomenu: usato per estendere il menu ed evitare variabile a 16/32 bit, default = 0
Revisione: 1
Note:	
*/
void lcd_menu(int livello,int sottomenu=0){
   lcd_putc("\f");                  
   switch (livello){
      case 0:
         switch (pag){
            case ORA:
               lcd_putc("   :     /  /\n");
               lcd_putc("Mem ->   /  /");
               break;   
            case DATI:
               lcd_putc("T=    C RH=    %");
               break;
            default: // segnalare errore
               lcd_putc("ERR0");
               break;
            }      
         break;     
      case 1:
         switch (pag){
            case 1:
               lcd_putc("Temperatura");
               break;   
            case 2:
               lcd_putc("Umidita'");
               break;   
            case 3:
               lcd_putc("Orologio");
               break;   
            case 4:
               lcd_putc("Setup");
               break;   
            case 5:
               lcd_esci(); 
               break; 
            default: // segnalare errore
               lcd_putc("ERR1");
               break;
         }
         break; 
      case 11:                         //Temperatura
         switch (pag){
            case 1:
               lcd_putc("Tmin     C");
               lcd_gotoxy(8,1); if (Tmin.valido== NO ) lcd_putc("??");   
                                else scrivi_num(Tmin.valore);
               break;   
            case 2:
               lcd_putc("Tmax     C");
               lcd_gotoxy(8,1); if (Tmax.valido== NO ) lcd_putc("??");
                                else scrivi_num(Tmax.valore);
               break;   
            case 3:
               lcd_putc("Tcomp");
               break;   
            case 4:    
               lcd_esci();
               break; 
            default: // segnalare errore
               lcd_putc("ERR11");
               break;
         }     
         break;   
      case 111:                         //Temperatura - Tmin
         if(pag<PRESE_QTY_1){
            lcd_putc("T<min presa");
            scrivi_num(pag,NOSPAZIO); 
            lcd_putc(" ");           
            presa_azione(presa[pag-1].Tmin);
         }                               
         else lcd_esci();
         break;            
      case 112:                         //Temperatura - Tmin                 
         if(pag<PRESE_QTY_1){         
            lcd_putc("T>max presa");
            scrivi_num(pag,NOSPAZIO); 
            lcd_putc(" ");        
            presa_azione(presa[pag-1].Tmax);                                  
         }
         else lcd_esci();
         break;
      case 113:                         //Temperatura - Tmin
         if(pag<PRESE_QTY_1){         
            lcd_putc("Tcomp presa");
            scrivi_num(pag,NOSPAZIO);
            lcd_putc(" ");
            presa_azione(presa[pag-1].Tcomp);    // NN VA MOSTRA SEMPTRE QUEL VALORE      
         }
         else lcd_esci();
         break;







      case 12:                         //Umidit
         switch (pag){
            case 1:
               lcd_putc("RHmin    %");                             
               lcd_gotoxy(8,1); if (RHmin.valido== NO ) lcd_putc("??");
                                else scrivi_num(RHmin.valore);
               break;   
            case 2:
               lcd_putc("RHmax    %");
               lcd_gotoxy(8,1); if (RHmax.valido== NO ) lcd_putc("??");
                                else scrivi_num(RHmax.valore);
                                
                                
                                
                                
                                
                                
                                
               break;   
            case 3:
               lcd_putc("RHcomp");                
               break;   
            case 4:
               lcd_esci();
               break; 
            default: // segnalare errore
               lcd_putc("ERR12");
               break;
         }
         break;   
      case 121:                         //Umidit - RHmin
         if(pag<PRESE_QTY_1){
            lcd_putc("%<min presa");
            scrivi_num(pag,NOSPAZIO); 
            lcd_putc(" ");           
            presa_azione(presa[pag-1].RHmin);
         }                               
         else lcd_esci();
         break;            
      case 122:                         //Umidit - RHmax                 
         if(pag<PRESE_QTY_1){                           
            lcd_putc("%>max presa");
            scrivi_num(pag,NOSPAZIO); 
            lcd_putc(" ");        
            presa_azione(presa[pag-1].RHmax);                                  
         }                           
         else lcd_esci();
         break;
      case 123:                         //Umidit - RHcomp
         if(pag<PRESE_QTY_1){         
            lcd_putc("%comp presa");
            scrivi_num(pag,NOSPAZIO);
            lcd_putc(" ");
            presa_azione(presa[pag-1].RHcomp);    // NN VA MOSTRA SEMPTRE QUEL VALORE      
         }                                                     
         else lcd_esci();                                 
         break;
      case 13:                         //Orologio        
         switch (pag){                                           
            case 1:
               lcd_putc("Mode 1"); 
               if (orologio_mode== MODE1 ){ lcd_gotoxy(8,1); lcd_putc("X");}   
               break;
            case 2:
               lcd_putc("Mode 2");
               if (orologio_mode== MODE2 ){ lcd_gotoxy(8,1); lcd_putc("X");}   
               break;
            case 3:  
               lcd_putc("Non usato");
               if (orologio_mode== MODE_NO ){ lcd_gotoxy(11,1); lcd_putc("X");}   
               break;          
            case 4:
               lcd_esci();
               break; 
            default: // segnalare errore
               lcd_putc("ERR11");
               break;
         }     
         break; 
      case 131:                         //Mode 1
         switch (sottomenu){             
            case 0: 
               if(pag<PRESE_QTY_1){  // la pagina corrisponde alla presa selezionata -1
                  lcd_putc("P");
                  scrivi_num(pag,NOSPAZIO); 
                  lcd_gotoxy(4,1); 
                  if(presa[pag-1].global_pass==NO) lcd_putc("??:?? - ??:??");
                  else{   
                     scrivi_num(presa[pag-1].on_hh,ZERO );
                     lcd_putc(":");                      
                     scrivi_num(presa[pag-1].on_mm,ZERO );
                     lcd_putc(" - ");
                     scrivi_num(presa[pag-1].off_hh,ZERO );
                     lcd_putc(":");
                     scrivi_num(presa[pag-1].off_mm,ZERO );
                  }
               }                           
               else lcd_esci(); 
               break;
            case 1: //1311
               switch(pag){
                  
                  // Se l'orario  valido lo mostra in base alla presa scelta nel menu precedente
                  //  (pagina != da presa_selezionata)   
                  case 1: 
                     lcd_putc("On");
                     lcd_gotoxy(10,1);                
                     if(presa[presa_scelta].on_pass==NO) lcd_putc("??:??");
                     else{
                        scrivi_num(presa[presa_scelta].on_hh,ZERO ); // stesse del menu sopra
                        lcd_putc(":");                      
                        scrivi_num(presa[presa_scelta].on_mm,ZERO );
                     }          
                     break;
                  case 2: 
                     lcd_putc("Off");
                     lcd_gotoxy(10,1);                
                     if(presa[presa_scelta].off_pass==NO) lcd_putc("??:??");
                     else{
                        scrivi_num(presa[presa_scelta].off_hh,ZERO );
                        lcd_putc(":");
                        scrivi_num(presa[presa_scelta].off_mm,ZERO );
                     }             
                     break;
                  case 3: 
                     lcd_esci();
                     break;    
               }
               break;  
           // case 11:  // 131 11
                                                                
             //  break;                                 
            
         }                                             
         break;                                         
      case 132:               //menu orologio    
         if(pag<PRESE_QTY_1){                           
            lcd_putc("Presa");
            scrivi_num(pag); 
         }                           
         else lcd_esci(); 
         break;
       
      case 141:                         //ora/data  
            switch (pag){
               case 1:
                  lcd_putc("Ora"); 
                  // l'ora la scrive en_MENU_1_4_1() & en_MENU_1_4_1_1()
                  break;
               case 2:
                  lcd_putc("Data");
                  // la data la scrive en_MENU_1_4_1() & en_MENU_1_4_1_2()
                  break;
               case 3:  
                  lcd_putc("Mem:");
                  // la data la scrive en_MENU_1_4_1() & en_MENU_1_4_1_3()
                  break;    
               case 4:
                  lcd_esci();
                  break; 
               default: // segnalare errore
                  lcd_putc("ERR141");
                  break;
            }     
            break;
         
     case 142:                         //backlight
         switch (pag){                                           
            case 1:
               lcd_putc("On"); 
               lcd_gotoxy(8,2); lcd_putc("X");
               break;
            case 2:
               lcd_putc("Off");
               lcd_gotoxy(8,2); lcd_putc("X"); 
               break;
            case 3:
               lcd_putc("Power saver");
               lcd_gotoxy(8,2); lcd_putc("X"); 
               break;
               
            case 4:
               lcd_esci();
               break; 
            default: // segnalare errore
               lcd_putc("ERR142");
               break;
         }     
         break; 
         
      case 143:                         //buzzer     
         switch (pag){                                           
            case 1:
               lcd_putc("Abilitato"); 
               lcd_gotoxy(9,1); lcd_putc("Si");
               break;
           
            case 2:
               lcd_esci();
               break; 
            default: // segnalare errore
               lcd_putc("ERR143");
               break;
         }     
         break; 
      case 144:                         //sensore luce   
         switch (pag){                                           
            case 1:
               lcd_putc("Presente"); 
               lcd_gotoxy(9,1); lcd_putc("Si");
               break;
           case 2:
               lcd_putc("Fine allarme"); 
               lcd_gotoxy(9,1); lcd_putc("Si");
               break;
           case 3:
               lcd_putc("Presente"); 
               lcd_gotoxy(9,1); lcd_putc("Si");
               break;
           
            case 4:
               lcd_esci();
               break; 
            default: // segnalare errore
               lcd_putc("ERR143");
               break;
         }     
         break; 
         
      case 14:                         //Orologio        
         switch (pag){                                           
            case 1:
               lcd_putc("Ora/data/salvata"); 
               break;
            case 2:
               lcd_putc("Backlight");
                break;
            case 3:  
               lcd_putc("Buzzer");
               break;         
            case 4:  
               lcd_putc("Sensore luce opz");
               break; 
            case 5:
               lcd_esci();
               break; 
            default: // segnalare errore
               lcd_putc("ERR14");
               break;
         }     
         break; 
         
      default: // segnalare errore
         lcd_putc("\fERR lev");
         break;
      
   } // chiude switch

}

/*
Funzione: void menu_scorri(int livello,int sottomenu=0)
Scopo: Gestisce lo scorrimento tra le schermate del menu
Ritorna: -
Parametri:
	livello: livelo del menu
	sottomenu: sottomenu: usato per estendere il menu ed evitare variabile a 16/32 bit, default 0
Revisione: 1
Note:	
*/
void menu_scorri(int livello,int sottomenu=0){

// ok allora gestisco il funzionamento in questo menu
   if (p_valido==GIU){ // scorrimento schermata down
      p_valido=NESSUNO;
      if (pag<pag_limit){
         pag++;     
         lcd_menu(livello,sottomenu);                  
      }
   }
   else if (p_valido==SU){  // scorrimento schermata up
      p_valido=NESSUNO;
      if (pag>1){
         pag--;
         lcd_menu(livello,sottomenu);                    
      }                                   
   }
}                        
                          



                
