/*****************************

	menu_engigne.c

Rilasciato con licenza GNU GPL
	
******************************/
/*********************************************   

                SERVICE ROUTINE
         
**********************************************/
#define MENU_ESCI_Y  1
#define MENU_ESCI_N  0

void pag_set_limit(int limit,int1 int1Esci);
void en_L0();
void en_L0_REFRESH_1();
void en_L0_REFRESH_2();
void en_MENU_0_1();
void en_MENU_0_2();
void en_MENU_1_1_1_1_1();
void en_MENU_1_1_1_1();
void en_MENU_1_1_1();
void en_MENU_1_1_2_1_1();
void en_MENU_1_1_2_1();
void en_MENU_1_1_2();
void en_MENU_1_1_3_1();
void en_MENU_1_1_3();
void en_MENU_1_1();
void en_MENU_1_2_1_1_1();
void en_MENU_1_2_1_1();
void en_MENU_1_2_1();
void en_MENU_1_2_2_1_1();
void en_MENU_1_2_2_1();
void en_MENU_1_2_2();
void en_MENU_1_2_3_1();
void en_MENU_1_2_3();
void en_MENU_1_2();
void en_MENU_1_3_1_1_1();
void en_MENU_1_3_1_1();
void en_MENU_1_3_1();
void en_MENU_1_3_2_1_1();
void en_MENU_1_3_2_1();
void en_MENU_1_3_2();
void en_MENU_1_3();
void en_MENU_REFRESH_DATE();
void en_MENU_1_4_1_3();
void en_MENU_1_4_1_2();
void en_MENU_1_4_1_1();
void en_MENU_1_4_1();
void en_MENU_1_4();
void en_MENU_1();
void en_MENU();
void en_MENU_SCREEN_ATTIVO();


/*
Funzione: void pag_set_limit(int limit,int1 int1Esci)
Scopo: Imposta i limiti di pagina e la pagina corrente per i vari menu
Ritorna: -
Parametri: 
	int limit: numero massimo di pagine per il menu che verr presentato
	int1 int1Esci: indica se  stata chiamata dopo aver scelto la voce di menu "Esci"
Revisione: 4
Note: -
*/ 
void pag_set_limit(int limit,int1 int1Esci){
   if(int1Esci==MENU_ESCI_Y) pag=0;
   pag_limit=limit; // schermate del menu livello 1                
}


/*********************************************   

     ROUTINE PER OGNI LIVELLO DLE MENU
         
**********************************************/

/*
      ENGIGNE:
Quando si entra in un menu si setta man mano 
che si va in rofondit il flag relativo
mentre man mano che si retrocede si resetta 
il flag del menu da cui si  usciti.
Cos, se l'utente sar nel menu 1_1_4, ci saranno 
settati i flag lev.L_1, lev.L_1_1 e lev.L_1_1_4.


*/

/*
Funzione: void en_L0()
Scopo: Sceglie la schermata da visualizzare quando si  usciti dai menu
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_L0(){
   p_valido=NESSUNO;
   if(screen_attivo==ORA)  screen_attivo=DATI;
   else                    screen_attivo=ORA;
}

/*
Funzione: void en_L0_REFRESH_1()
Scopo: Imposta schermata del menu 0
Ritorna: -
Parametri: 
Revisione: 2
Note: -
*/ 
void en_L0_REFRESH_1(){
   pag=screen_attivo;
   lcd_menu(0);  // prepara parole nella schermata
   dec_sec=1;          // forza inserimento dei valori istantaneamente 
}

/*
Funzione: void en_L0_REFRESH_2()
Scopo: Prepara il menu per mostrare il menu di livello 1
Ritorna: -
Parametri: 
Revisione: 2
Note: -
*/ 
void en_L0_REFRESH_2(){
// entrata nel menu                                                               
   screen_attivo=NESSUNO;            //ferma aggiornamento delle schermate di stand-by
   p_valido=NESSUNO;
   lev.L_0=NO;
   lev.L_1=SI; 
   lcd_putc("\fMENU 1");
   pag_set_limit(L1_LIMITE,MENU_ESCI_Y); // schermate del menu livello 1                  
}

/*
Funzione: void en_MENU_0_1()
Scopo: Calcola e mostra i dati del sensore
Ritorna: -
Parametri: 
Revisione: 5
Note: -
*/ 
void en_MENU_0_1(){
//http://www.sensirion.com/en/pdf/product_information/Non-Linearity_Compensation_Humidity_Sensors_E.pdf
//8% ROM @ 18F45K22 !!

   unsigned long sot,soh;
   signed long sot_s;
   float rel_humidity, temperature_c;
   
   sot = ReadTemperature();
   // v3 & v4
   sot_s= (signed long)(sot - 7000 );
   temperature_c = -40.1 + (float)(0.01 * sot) +  (float)( -2E-8 * sot_s * sot_s) ;  
   
   soh = ReadHumidity();
   //v3 vs v4 with unknown sensor version: different: +-1%
   //v3:-4 + (float)(0.0405 * soh) +  (float)( -2.8000E-6 * soh * soh) ; 
   //v4:-2.0468 + (float)(0.0367 * soh) +  (float)( -1.5955E-6 * soh * soh) ; 
   
   rel_humidity = -2.0468 + (float)(0.0367 * soh) +  (float)( -1.5955E-6 * soh * soh) ;
     
   t_int= (int)temperature_c; 
   rh_int=(int)rel_humidity;  
     
   lcd_gotoxy(3,1);   printf(lcd_putc,"%2.1g",temperature_c);//scrivi_num(adc);//T
   lcd_gotoxy(12,1);   printf(lcd_putc,"%2.1g",rel_humidity ); //scrivi_num(adc);//RH
   // x debug: lcd_gotoxy(1,2);   printf(lcd_putc,"%u %u %u",rh_int,RHmin.valore,RHmax.valore);
 
}

/*
Funzione: void en_MENU_0_2()
Scopo: Mostra ora e data corrente e quella memorizzata in eeprom
Ritorna: -
Parametri: 
Revisione: 3
Note: -
*/                           
void en_MENU_0_2(){
   lcd_gotoxy(2,1);   scrivi_num(rtc.hh,ZERO); //ora, antempone uno 0 se il numero  < di 10  
   lcd_gotoxy(5,1);   scrivi_num(rtc.mm,ZERO); //min
   
   lcd_gotoxy(8,1);   scrivi_num(rtc.day,ZERO); //ora, antempone uno 0 se il numero  < di 10
   lcd_gotoxy(11,1);  scrivi_num(rtc.mth,ZERO); //min
   lcd_gotoxy(14,1);  scrivi_num(rtc.yy,ZERO); //gg
   
   lcd_gotoxy(8,2);   scrivi_num(ee_get_day(),ZERO); //ora, antempone uno 0 se il numero  < di 10
   lcd_gotoxy(11,2);  scrivi_num(ee_get_mth(),ZERO); //min
   lcd_gotoxy(14,2);  scrivi_num(ee_get_yy(),ZERO); //gg
}          
 
/*
Funzione: void en_MENU_1_1_1_1_1()
Scopo: Offre scelta valori in on/off/?? per Tmin e salva la scelta se confermata
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/   
void en_MENU_1_1_1_1_1(){
   temp_presa.Tmin=presa_parametro_get(temp_presa.Tmin); 
   if (p_valido==SET){  // stato della prersa impostata       
      p_valido=NESSUNO;               
      presa[pag-1]=temp_presa;                          
      lcd_gotoxy(13,1);
      lcd_putc(" "); // cancella freccia
      lev.L_1_1_1_1_1=NO; 
      // rimane su questa voce, permettendo di poter modificere le altre prese
   }
}
   
/*
Funzione: void en_MENU_1_1_1_1()
Scopo: Propone la presa su cui lavorare per Tmin e predispone i parametri per il sottomenu 
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_1_1_1(){   
   menu_scorri(111); // scelta presa su cui lavorare 
   if (p_valido==SET){  // E' stata scelta una voce del menu scelta presa  
      p_valido=NESSUNO;
      if (pag==L1_1_1_LIMITE){ // clic su Esci              
         lev.L_1_1_1=NO;
         lev.L_1_1_1_1=NO; 
         scritta_mostrata=NO;
         lcd_putc("\fMENU 1_1");
         pag_set_limit(L1_1_LIMITE,MENU_ESCI_Y);
      }                                 
      else if (pag>0){ // clic una presa 
         // else ha cliccato sulla presa, ora devo fargli scegliere il valore su cui si deve impostare
         lcd_gotoxy(13,1);
         lcd_putc(">");
         lev.L_1_1_1_1_1=SI;  
         temp_presa=presa[pag-1];  // copia propriet di quella presa nelle temporanee x poterle elaborare senza danni.       
      }      
      //else ha cliccato sul nome, nessun azione da eseguire
   }    
} 

/*
Funzione: void en_MENU_1_1_1()
Scopo: Propone di scegliere una presa per impostare l'azione da intrapprendere quando la temperatura  al di sotto della soglia impostata
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_1_1(){
   temp_soglia_get();                                  
   if (p_valido==SET){    
      Tmin.valore=temp_soglia.valore; 
      Tmin.valido=temp_soglia.valido; 
      
      p_valido=NESSUNO;
      lcd_gotoxy(7,1);
      lcd_putc(" ");
               
      // soglia impostata...                
      if (temp_soglia.valido==NO){ // ...ma resa invalida    
         Tmax.min=SOGLIA_MIN;
         lev.L_1_1_1=NO;
         goto END; // nessuna soglia impostata, non posso imostare il funzionamento delle prese
      }
      // ...e valida                           
      Tmax.min=Tmin.valore;// il minimo valore di Tmax= al valore della soglia di Tmin
      
      delay_ms(DELAY_COMPARSA_MENU);
      // imposto lo stato su cui si devono impostare le prese
      lev.L_1_1_1_1=SI;  
      lcd_putc("\fMENU 1_1_1");
      pag_set_limit(L1_1_1_LIMITE,MENU_ESCI_Y);                                    
   }
END:
#ASM
nop
#ENDASM

}

/*
Funzione: void en_MENU_1_1_2_1_1()
Scopo: Offre scelta valori in on/off/?? per Tmax e salva la scelta se confermata
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/   
void en_MENU_1_1_2_1_1(){
   temp_presa.Tmax=presa_parametro_get(temp_presa.Tmax); // offre scelta valori in on/off/??
   if (p_valido==SET){  // stato della prersa impostata       
      p_valido=NESSUNO;               
      presa[pag-1]=temp_presa;                          
      lcd_gotoxy(13,1);
      lcd_putc(" "); // cancella freccia
      lev.L_1_1_2_1_1=NO; 
      // rimane su questa voce, permettendo di poter modificere le altre prese
   }


}

/*
Funzione: void en_MENU_1_1_2_1()
Scopo: Propone la presa su cui lavorare per Tmax e predispone i parametri per il sottomenu 
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_1_2_1(){
   menu_scorri(112); // scelta presa su cui lavorare 
   if (p_valido==SET){  // E' stata scelta una voce del menu scelta presa  
      p_valido=NESSUNO;
      if (pag==L1_1_2_LIMITE){ // clic su Esci              
         lev.L_1_1_2=NO;
         lev.L_1_1_2_1=NO; 
         scritta_mostrata=NO;
         lcd_putc("\fMENU 1_1");
         pag_set_limit(L1_1_LIMITE,MENU_ESCI_Y);
         goto END;
      }                                 
      else if (pag>0){ // clic una presa 
         // else ha cliccato sulla presa, ora devo fargli scegliere il valore su cui si deve impostare
         lcd_gotoxy(13,1);
         lcd_putc(">");
         lev.L_1_1_2_1_1=SI;  
         temp_presa=presa[pag-1];  // copia propriet di quella presa nelle temporanee x poterle elaborare senza danni.       
      }      
      //else ha cliccato sul nome        
   }  
   
END:
   #ASM
   nop
   #ENDASM
}

/*
Funzione: void en_MENU_1_1_2()
Scopo: Propone di scegliere una presa per impostare l'azione da intrapprendere quando la temperatura  al di sopra della soglia impostata
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_1_2(){
   temp_soglia_get();                                  
   if (p_valido==SET){    
      p_valido=NESSUNO;          
      Tmax.valore=temp_soglia.valore;
      Tmax.valido=temp_soglia.valido;
      
      lcd_gotoxy(7,1);
      lcd_putc(" ");
      // soglia impostata...                
      if (Temp_soglia.valido==NO){ // ...ma resa invalida    
         Tmin.max=SOGLIA_MAX;
         lev.L_1_1_2=NO;
         goto END; // nessuna soglia impostata, non posso imostare il funzionamento delle prese
      }                         
      // ...e valida
      
      Tmin.max=Tmax.valore;// il massimo valore di Tmin= al valore della soglia di Tmax
     
      delay_ms(DELAY_COMPARSA_MENU);
      // imposto lo stato su cui si devono impostare le prese
      lev.L_1_1_2_1=SI;  
      lcd_putc("\fMENU 1_1_2"); 
      pag_set_limit(L1_1_2_LIMITE,MENU_ESCI_Y);
                                          
   }
   
END:
   #ASM
   nop
   #ENDASM
}

/*
Funzione: void en_MENU_1_1_3_1()
Scopo: Propone la presa su cui lavorare per Tcomp e predispone i parametri per il sottomenu 
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_1_3_1(){
   temp_presa.Tcomp=presa_parametro_get(temp_presa.Tcomp); // ofre scelta valori in on/off/??
                                                       
   if (p_valido==SET){  // presa scelta
      p_valido=NESSUNO;               
      
      presa[pag-1]=temp_presa;
      lcd_gotoxy(13,1);
      lcd_putc(" "); // cancella freccia
      lev.L_1_1_3_1=NO;      
      // rimane su questa voce, permettendo di poter modificere le altre prese
   }
}

/*
Funzione: void en_MENU_1_1_3()
Scopo: Propone di scegliere una presa per impostare l'azione da intrapprendere quando la temperatura  compresa tra le soglie impostate
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_1_3(){
   // mostra scelta prese  
   menu_scorri(113); // scelta presa su cui lavorare 
   if (p_valido==SET){  // E' stata scelta una voce del menu scelta presa  
      p_valido=NESSUNO;
      if (pag==L1_1_3_LIMITE){ // clic su Esci              
         lev.L_1_1_3=NO;            
         scritta_mostrata=NO;
         lcd_putc("\fMENU 1_1");
         pag_set_limit(L1_1_LIMITE,MENU_ESCI_Y);
         goto END;
      }                                 
      else if (pag>0){ // clic una presa   
      
         // else ha cliccato sulla presa, ora devo fargli scegliere il valore su cui si deve impostare
         lcd_gotoxy(13,1);
         lcd_putc(">");
         lev.L_1_1_3_1=SI;  
         temp_presa=presa[pag-1];  // copia propriet di quella presa nelle temporanee x poterle elaborare senza danni.       
      }      
      //else ha cliccato sul nome
   } 
   
END:
   #ASM
   nop
   #ENDASM  
}

/*
Funzione: void en_MENU_1_1()
Scopo: Menu temperatura
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_1(){
   menu_scorri(11);
   if (p_valido==SET){ 
      p_valido=NESSUNO;
      switch(pag){
         case 1:            // Tmin                                                                    
            lev.L_1_1_1=SI;                                                                                     
            lcd_gotoxy(7,1);
            lcd_putc(">");        
            temp_soglia=Tmin; 
            break;
         case 2:           // Tmax
            lev.L_1_1_2=SI; 
            lcd_gotoxy(7,1);
            lcd_putc(">");
            temp_soglia=Tmax;
            break;
         case 3:           //Tcomp
            lev.L_1_1_3=SI;        
            pag=0; // cosi quando entra di nuovo nel menu parte dalla prima pagina
            break;      
         case 4:           // Esci
            lev.L_1_1=NO; 
            lcd_putc("\fMENU 1");
            pag_set_limit(L1_LIMITE,MENU_ESCI_Y);                  
            break;      
      }
   }               
}

/*
Funzione: void en_MENU_1_2_1_1_1()
Scopo: Offre scelta valori in on/off/?? per RHmin e salva la scelta se confermata
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_2_1_1_1(){
   temp_presa.RHmin=presa_parametro_get(temp_presa.RHmin); // offre scelta valori in on/off/??
   if (p_valido==SET){  // stato della prersa impostata       
      p_valido=NESSUNO;               
      presa[pag-1]=temp_presa;                          
      lcd_gotoxy(13,1);
      lcd_putc(" "); // cancella freccia
      lev.L_1_2_1_1_1=NO; 
      // rimane su questa voce, permettendo di poter modificere le altre prese
   }
}

/*
Funzione: void en_MENU_1_2_1_1()
Scopo: Propone la presa su cui lavorare per RHmin e predispone i parametri per il sottomenu 
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_2_1_1(){
   menu_scorri(121); // scelta presa su cui lavorare 
   if (p_valido==SET){  // E' stata scelta una voce del menu scelta presa  
      p_valido=NESSUNO;
      if (pag==L1_2_1_LIMITE){ // clic su Esci              
         lev.L_1_2_1=NO;
         lev.L_1_2_1_1=NO; 
         scritta_mostrata=NO;
         lcd_putc("\fMENU 1_2");
         pag_set_limit(L1_2_LIMITE,MENU_ESCI_Y );
         goto END;
      }                                 
      else if (pag>0){ // clic una presa   
      
         // else ha cliccato sulla presa, ora devo fargli scegliere il valore su cui si deve impostare
         lcd_gotoxy(13,1);
         lcd_putc(">");
         lev.L_1_2_1_1_1=SI;  
         temp_presa=presa[pag-1];  // copia propriet di quella presa nelle temporanee x poterle elaborare senza danni.       
      }      
      //else ha cliccato sul nome
   }
END:
   #ASM
   nop
   #ENDASM 
}

/*
Funzione: void en_MENU_1_2_1()
Scopo: Propone di scegliere una presa per impostare l'azione da intrapprendere quando l'umidit  al di sotto della soglia impostata
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_2_1(){
   temp_soglia_get();                                  
   if (p_valido==SET){    
      p_valido=NESSUNO;          
      RHmin.valido=temp_soglia.valido;                 
      RHmin.valore=temp_soglia.valore;                 
      
      lcd_gotoxy(6,1);
      lcd_putc(" ");
      
      // soglia impostata...
      if (temp_soglia.valido==NO){ // ...ma resa invalida    
         RHmax.min=SOGLIA_MIN;
         lev.L_1_2_1=NO;
        // nessuna soglia impostata, non posso impostare il funzionamento delle prese
      }
      else{
      
         RHmax.min=RHmin.valore;  // il minimo valore di RHmax= al valore della soglia di RHmin
          
         delay_ms(DELAY_COMPARSA_MENU);
         // imposto lo stato su cui si devono impostare le prese
         lev.L_1_2_1_1=SI;         
         lcd_putc("\fMENU 1_2_1");
         pag_set_limit(L1_2_1_LIMITE,MENU_ESCI_Y);
      }                        
   }
}

/*
Funzione: void en_MENU_1_2_2_1_1()
Scopo: Offre scelta valori in on/off/?? per RHmax e salva la scelta se confermata
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/  
void en_MENU_1_2_2_1_1(){
   temp_presa.RHmax=presa_parametro_get(temp_presa.RHmax); // offre scelta valori in on/off/??
   if (p_valido==SET){  // stato della prersa impostata       
      p_valido=NESSUNO;                             
      presa[pag-1]=temp_presa;                          
      lcd_gotoxy(13,1);
      lcd_putc(" "); // cancella freccia
      lev.L_1_2_2_1_1=NO; 
      // rimane su questa voce, permettendo di poter modificere le altre prese
   }
}
 
/*
Funzione: void en_MENU_1_2_2_1()
Scopo: Propone la presa su cui lavorare per RHmax e predispone i parametri per il sottomenu 
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/  
void en_MENU_1_2_2_1(){
   menu_scorri(122); // scelta presa su cui lavorare 
   if (p_valido==SET){  // E' stata scelta una voce del menu scelta presa  
      p_valido=NESSUNO;
      if (pag==L1_2_2_LIMITE){ // clic su Esci              
         lev.L_1_2_2=NO;
         lev.L_1_2_2_1=NO; 
         scritta_mostrata=NO;
         lcd_putc("\fMENU 1_2");
         pag_set_limit(L1_2_LIMITE,MENU_ESCI_Y);
         goto END;
      }                                 
      else if (pag>0){ // clic una presa   
      
         // else ha cliccato sulla presa, ora devo fargli scegliere il valore su cui si deve impostare
         lcd_gotoxy(13,1);
         lcd_putc(">");
         lev.L_1_2_2_1_1=SI;  
         temp_presa=presa[pag-1];  // copia propriet di quella presa nelle temporanee x poterle elaborare senza danni.       
      }      
      //else ha cliccato sul nome               
   }
END:
   #ASM
   nop
   #ENDASM  
}

/*
Funzione: void en_MENU_1_1_2()
Scopo: Propone di scegliere una presa per impostare l'azione da intrapprendere quando l'UMIDIT  al di sopra della soglia impostata
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_2_2(){
   temp_soglia_get();                                  
   if (p_valido==SET){    
      p_valido=NESSUNO;          
      RHmax.valido=temp_soglia.valido;                      
      RHmax.valore=temp_soglia.valore;                      
      
      lcd_gotoxy(6,1);
      lcd_putc(" ");   
      
      // soglia impostata...                
      if (temp_soglia.valido==NO){ // ...ma resa invalida    
         // quindi bisogna sistemare i parametri di RHmin
         RHmin.max=SOGLIA_MAX;  // il massimo valore di RHmin= al valore della soglia di RHmax
         lev.L_1_2_2=NO;
         goto END; // nessuna soglia impostata, non posso imostare il funzionamento delle prese
      }                         
      // ...e valida
           
      RHmin.max=RHmax.valore;  // il massimo valore di RHmin= al valore della soglia di RHmax
      
      delay_ms(DELAY_COMPARSA_MENU);
      // imposto lo stato su cui si devono impostare le prese
      lev.L_1_2_2_1=SI;  
      lcd_putc("\fMENU 1_2_2");
      pag_set_limit(L1_2_2_LIMITE,MENU_ESCI_Y);                                         
   }
END:
   #ASM
   nop
   #ENDASM   
}

/*
Funzione: void en_MENU_1_1_3_1()
Scopo: Propone la presa su cui lavorare per RHcomp e predispone i parametri per il sottomenu 
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_2_3_1(){
   temp_presa.RHcomp=presa_parametro_get(temp_presa.RHcomp); // ofre scelta valori in on/off/??
                                                       
   if (p_valido==SET){  // presa scelta
      p_valido=NESSUNO;               
      
      presa[pag-1]=temp_presa;
      lcd_gotoxy(13,1);
      lcd_putc(" "); // cancella freccia
      lev.L_1_2_3_1=NO;      
      // rimane su questa voce, permettendo di poter modificere le altre prese
   }
}

/*
Funzione: void en_MENU_1_2_3()
Scopo: Propone di scegliere una presa per impostare l'azione da intrapprendere quando l'umidit  compresa tra le soglie impostate
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_2_3(){
   // mostra scelta prese  
   menu_scorri(123); // scelta presa su cui lavorare 
   if (p_valido==SET){  // E' stata scelta una voce del menu scelta presa  
      p_valido=NESSUNO; 
      if (pag==L1_2_3_LIMITE){ // clic su Esci              
         lev.L_1_2_3=NO;            
         scritta_mostrata=NO;
         lcd_putc("\fMENU 1_2");
         pag_set_limit(L1_2_LIMITE,MENU_ESCI_Y);
         goto END;
      }                                 
      else if (pag>0){ // clic una presa   
      
         // else ha cliccato sulla presa, ora devo fargli scegliere il valore su cui si deve impostare
         lcd_gotoxy(13,1);
         lcd_putc(">");
         lev.L_1_2_3_1=SI;  
         temp_presa=presa[pag-1];  // copia propriet di quella presa nelle temporanee x poterle elaborare senza danni.       
      }      
      //else ha cliccato sul nome
   }    
END:
   #ASM
   nop
   #ENDASM 
}

/*
Funzione: void en_MENU_1_2()
Scopo: Menu umidit
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_2(){
   menu_scorri(12); 
   if (p_valido==SET){ 
      p_valido=NESSUNO;
      switch(pag){
         case 1:            // RHmin                                                                    
            lev.L_1_2_1=SI;                                                                                     
            lcd_gotoxy(7,1);
            lcd_putc(">");            
            temp_soglia=RHmin; 
            break;
         case 2:           // RHmax
            lev.L_1_2_2=SI; 
            lcd_gotoxy(7,1);
            lcd_putc(">");
            temp_soglia=RHmax;
            break;
         case 3:           //RHcomp
            lev.L_1_2_3=SI;        
            pag=0; // cosi quando entra di nuovo nel menu parte dalla prima pagina
            break;      
         case 4:           // Esci
            lev.L_1_2=NO; 
            lcd_putc("\fMENU 1"); 
            pag_set_limit(L1_LIMITE,MENU_ESCI_Y);   
            break;      
      }
   }
}

/*
Funzione: void en_MENU_1_3_1_1_1()
Scopo: Imposta scelta dell'orario per accensione e spegnimento della presa x per il funzionamento dell'orologio in mode 1
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_3_1_1_1(){
   if(lcd_orologio_scorri()==TRUE) lcd_orologio_step_calc();
   else if (p_valido==SET){
      p_valido=NESSUNO;                       
      if (presa_opz==OFF){
         presa[presa_scelta].off_pass=temp_presa.off_pass;
         if(temp_presa.off_pass==SI){
            presa[presa_scelta].off_hh=hh_scelta; // calcolate in orologio step calc
            presa[presa_scelta].off_mm=mm_scelta;
         }
         else{
            presa[presa_scelta].off_hh=0; // calcolate in orologio step calc
            presa[presa_scelta].off_mm=0;
         }
         pag=2;
      }
      else{// on
         presa[presa_scelta].on_pass=temp_presa.on_pass;
         if(temp_presa.on_pass==SI){
            presa[presa_scelta].on_hh=hh_scelta; // calcolate in orologio step calc
            presa[presa_scelta].on_mm=mm_scelta;
         }
         else{
            presa[presa_scelta].on_hh=0; // calcolate in orologio step calc
            presa[presa_scelta].on_mm=0;
         }
         pag=1; // ritorna alla pagina di on
      }
      lcd_selez_orologio_canc(); // cancella frecce a dx e sx dell'orario
      pag_set_limit(L1_3_1_1_LIMITE,MENU_ESCI_N);          
      lev.L_1_3_1_1_1=NO;   
   }
}

/*
Funzione: void en_MENU_1_3_1_1()
Scopo: Imposta scelta della presa a cui modificare l'orario di on e off per il funzionamento dell'orologio in mode 1
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_3_1_1(){   
   menu_scorri(131,1); // 2 scelte: on/off alle xx:xx
   if (p_valido==SET){
      p_valido=NESSUNO;
      
      // Esce se premuto esci
      // altrimenti se premuto in una schermata, la gestisce
      if (pag==L1_3_1_1_LIMITE){ // esci
        
         // controlla se ha impostato sia l'orario di on che quello di off.
         //  se non sono impostati etrambi, li rende invalidi entrambi
         //  perch non  possibile che uno imposti solo l'orario di on e non quello di off e viceversa
         //  in questo caso si suppone che l'utente sia sbadato e si prevengono malfunzionamenti.
         
         if((presa[presa_scelta].on_pass==TRUE) && (presa[presa_scelta].off_pass==TRUE)) presa[presa_scelta].global_pass=TRUE;
         else{
            presa[presa_scelta].on_pass=FALSE;
            presa[presa_scelta].oFF_pass=FALSE;
            presa[presa_scelta].global_pass=FALSE;
            
            lcd_putc("\fValori invalidi");
            delay_ms(DELAY_COMPARSA_ERR);
         }
         pag_set_limit(L1_3_1_LIMITE,MENU_ESCI_Y);          
         lev.L_1_3_1_1=NO;
         lcd_putc("\fMENU 1_3_1");
      }   
      else if(pag>0){ //(1-2, 3 ESCE SOPRA) almeno in pagina 1, pagina 0 non tollerata  
         pag_back=pag; // on o off

         
         if (pag==1){//impostazione On
            presa_opz=ON;
            temp_presa.on_hh=presa[presa_scelta].on_hh;
            temp_presa.on_mm=presa[presa_scelta].on_mm;
            temp_presa.on_pass=TRUE;// vero perch clicco e compare 00:00, 
                                    // se l'utente preme set deve poterla prendere come valida
            
            pag=temp_presa.on_hh*6+temp_presa.on_mm/10+1;  // diviso 10 xk contiene numeri come 10, 20 ecc
                                                         // + 1 xk la prima pagina  spostada di 1 posizione
         }
         else{// impostazione Off
            presa_opz=OFF;
            temp_presa.off_hh=presa[presa_scelta].off_hh;
            temp_presa.off_mm=presa[presa_scelta].off_mm;
            temp_presa.off_pass=TRUE;// vero perch clicco e compare 00:00, 
                                    // se l'utente preme set deve poterla prendere comen valida
            
            pag=temp_presa.off_hh*6+temp_presa.off_mm/10+1;  // diviso 10 xk contiene numeri come 10, 20 ecc  
         }
         pag_set_limit(L1_3_1_1_1_LIMITE,MENU_ESCI_N); 
         lev.L_1_3_1_1_1=SI;
         orologio_step=MINUTI;
         lcd_selez_minuti();
         lcd_orologio_step_calc();
      }
   }
}

/*
Funzione: void en_MENU_1_3_1()
Scopo: Propone di scegliere una presa per impostare l'azione da intrapprendere  con orologio in Mode 1
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_3_1(){
   menu_scorri(131);          
   if (p_valido==SET){
      p_valido=NESSUNO;
      if (pag==L1_3_1_LIMITE){ // esci
         lev.L_1_3_1=NO;
         pag_set_limit(L1_3_LIMITE,MENU_ESCI_Y);        
         lcd_putc("\fMENU 1_3");
      } 
      else if(pag>0){ // ha scelto una presa,
         presa_scelta=pag-1; 
         lev.L_1_3_1_1=SI;       
         pag_set_limit(L1_3_1_1_LIMITE,MENU_ESCI_Y);                 
         lcd_putc("\fMENU 1_3_1_1");   
      }
   }        
}  
   
/*
Funzione: void en_MENU_1_3_2_1_1()
Scopo: Imposta scelta on/off ?? per ogni step di 10 minuti per la presa scelta, x per il funzionamento dell'orologio in mode 2
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/    
void en_MENU_1_3_2_1_1(){   
   temp_azione=presa_parametro_get(temp_azione); // ofre scelta valori in on/off/??
                                                         
   if (p_valido==SET){  // presa scelta
      p_valido=NESSUNO;
      
      presa[presa_scelta].Timer[hh_scelta][mm_scelta/10]=temp_azione;
      lcd_gotoxy(1,1);        
      lcd_putc(" "); // cancella freccia dall'azione che dovr fare la presa
                     //  e la ridisegna in parte ai minuti o all'ora(in base a dove stava prima di premere set) 
      if(orologio_step==MINUTI) lcd_selez_minuti(); // disegna freccia 
      else if(orologio_step==ORE) lcd_selez_ore(); // disegna freccia 
   
      lev.L_1_3_2_1_1=NO; 
   }   
}  

/*
Funzione: void en_MENU_1_3_2_1()
Scopo: Imposta scelta dell'orario a cui assegnare il valore on/off ?? per ogni step di 10 minuti per la presa scelta, x per il funzionamento dell'orologio in mode 2
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/  
void en_MENU_1_3_2_1(){
   int state_old,z_part,j_part,j,z;
   
   if (lcd_orologio_scorri()==TRUE) lcd_azione_presa(); // SE CLICCATO  MOSTRA OROLOGIO                                                      
   
   if (p_valido==SET){  // orario scelto
      p_valido=NESSUNO;               
      if(pag==L1_3_2_1_LIMITE){ //ha premuto esci         
         
         /* algoritmo di autoimpostazione delle prese:
          - parte da 00:00 e cerka il primo valore impostato.
          - controlla il valore del sucessivo, se = a p_x, imposta il valore del precedente.
          - quando arriva a mezzanotte, continua in loop fino al valore da cui era partito(memorizzato)
          -se erano tutti vuoti... controlla quando arriva a mezzanotte se la variabile mem contiene un orario di partenza. se non c', vuol dire ch erano tutti vuoti.
         */
         state_old=P_X;
         z_part=ORA_X;
         j_part=ORA_X;
         
         for(j=0;j<24;j++){ // ore
            for(z=0;z<6;z++){ // minuti
               if (presa[presa_scelta].Timer[j][z]!=P_X){
               
                  // se ha trovato il primo valore diverso da p_x , imposta ora di partenza del ciclo
                  if ( z_part==ORA_X){  // basta controllare uno dei 2 valori..
                     z_part=z;
                     j_part=j;
                  }
                  // 
                  state_old=presa[presa_scelta].Timer[j][z]; // orario di partenza
               }  
               else { //== a p_x
               // ci copia il valore che deve tenere fino al prox valore.
                  presa[presa_scelta].Timer[j][z]=state_old;
               }
            }
         }   
         
         // controlla se deve rifinire di impostare i primi valori fino a dove ha trovato il primo valore giusto
         if(z_part!=ORA_X){  // basta controllare uno dei 2 valori..
            // per tutti i  minuti di ora in ora
           // sistema le ore complete
            if (j_part>0){
               for(j=0;j<j_part;j++){ // ore complete
                  for(z=0;z<6;z++)presa[presa_scelta].Timer[j][z]=state_old;
               } 
            }
            // minuti dell'ultima ora
            for(z=0;z<z_part;z++) presa[presa_scelta].Timer[j_part][z]=state_old; 
         }  
         
         lev.L_1_3_2_1=NO;
         pag_set_limit(L1_3_2_LIMITE,MENU_ESCI_Y); 
         lcd_putc("\fMENU 1_3_2");
         goto END;
      } 
      
      // altrimenti ha scelto un orario
      
      temp_azione=presa[presa_scelta].Timer[hh_scelta][mm_scelta/10];    
      lcd_selez_orologio_canc();// cancella freccia dall'orologio
      lcd_gotoxy(1,1);
      lcd_putc(">");// freccia in parte all'azione che dovr fare la presa
      lev.L_1_3_2_1_1=SI;                                     
      // nessun limite da impostare, mostro la scelta on/off/??     
   }   
END:
   #ASM
   nop
   #ENDASM    
}   

/*
Funzione: void en_MENU_1_3_1()
Scopo: Propone di scegliere una presa per impostare l'azione da intrapprendere  con orologio in Mode 2
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/    
void en_MENU_1_3_2(){  
   menu_scorri(132);    // scelta presa su cui lavorare
   if (p_valido==SET){
      p_valido=NESSUNO;
      if (pag==L1_3_2_LIMITE){ // esci
         lev.L_1_3_2=NO;  
         pag_set_limit(L1_3_LIMITE,MENU_ESCI_Y);          
         lcd_putc("\fMENU 1_3"); 
      } 
      else if(pag>0){ // almeno in pagina 1, pagina 0 non tollerata  
         // ha scelto una presa,
         presa_scelta=pag-1; 
         //ora deve scegliere un orario                           
                     
         lev.L_1_3_2_1pre=SI;       
         // sistema pagine nel menu pre
         lcd_putc("\fMENU 1_3_2");
      }                
   }  
}   
   
 /*
Funzione: void en_MENU_1_2()
Scopo: Menu orologio
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/   
void en_MENU_1_3(){
   menu_scorri(13);       
   if (p_valido==SET){ 
      p_valido=NESSUNO;
      if (pag>0){
         switch(pag){           
            case 1:            // Mode 1
               orologio_mode=MODE1;
               lcd_gotoxy(8,1); 
               lcd_putc("X");
               delay_ms(DELAY_COMPARSA_MENU);
               lev.L_1_3_1=SI; 
               pag_set_limit(L1_3_1_LIMITE,MENU_ESCI_Y);
               lcd_putc("\fMENU 1_3_1"); 
               break;
            case 2:           // Mode2 
               orologio_mode=MODE2;                     
               lcd_gotoxy(8,1); 
               lcd_putc("X");
               delay_ms(DELAY_COMPARSA_MENU);
               
               lev.L_1_3_2=SI;                
               pag_set_limit(L1_3_2_LIMITE,MENU_ESCI_Y);  
               lcd_putc("\fMENU 1_3_2");  
               break;
            case 3:           // Non usato 
               orologio_mode=MODE_NO;                     
               lcd_gotoxy(11,1); 
               lcd_putc("X\b");
               delay_ms(DELAY_COMPARSA_MENU);
               // prosegue in case 4
            case 4:           // Esci
               // scritta menu 1 gia fatta in testa al case
               lev.L_1_3=NO;
               pag_set_limit(L1_LIMITE,MENU_ESCI_Y);
               lcd_putc("\fMENU 1");
               break;
         }   
      } 
      //else clic sul titolo
   }          
}  

 /*
Funzione: void en_MENU_REFRESH_DATE()
Scopo: aggiorna la data su lcd
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/   
void en_MENU_REFRESH_DATE(){
   lcd_gotoxy(7,1);
   scrivi_num(setup.day,ZERO);
   lcd_putc("/");
   lcd_gotoxy(11,1);
   scrivi_num(setup.mth,ZERO); 
   lcd_putc("/");
   lcd_gotoxy(15,1);
   scrivi_num(setup.yy,ZERO);  
}

/*
Funzione: void en_MENU_1_4_1_3()
Scopo: permette di impostare una data da salvare in eeprom
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/   
void en_MENU_1_4_1_3(){

   if (lcd_setup_date()==1){   // setup data salvata in mem.
      // aggiorna il display solo se c' stato un cambiamento dell'ora
      en_MENU_REFRESH_DATE();
   }
   if (p_valido==SET){
      p_valido=NESSUNO;
      pag_set_limit(L1_4_1_LIMITE,MENU_ESCI_N);         
      lev.L_1_4_1_3=NO;
      
      lcd_selez_data_canc();//clean '>' and '<' around hh:mm
      if( validate_date(setup.day,setup.mth,setup.yy)==1){
         ee_write_date(setup.day,setup.mth,setup.yy);
      }
      //TODO: else write not valid @lcd
   }
}

/*
Funzione: void en_MENU_1_4_1_2()
Scopo: Permette la modifica della data dell'rtc
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/  
void en_MENU_1_4_1_2(){
   if (lcd_setup_date()==1){   // controlla se si cambia l'ora ed esegue i cambiamenti
      en_MENU_REFRESH_DATE();
   } 
   if (p_valido==SET){
      p_valido=NESSUNO;
      data_step=STEP_DD;//ripristina per la prossima esecuzione di lcd_rtc_setup_date()
      pag_set_limit(L1_4_1_LIMITE,MENU_ESCI_N);         
      lev.L_1_4_1_2=NO;
   
      lcd_selez_data_canc();//clean '>' before dd/ mm/ yy
      if( validate_date(setup.day,setup.mth,setup.yy)==1){
         rtc_set_date(setup.day,setup.mth,setup.yy);
         rtc.yy=setup.yy;
         rtc.mth=setup.mth;
         rtc.day=setup.day;
      }
      //TODO: else write not valid @lcd
   } 
}

/*
Funzione: void en_MENU_1_4_1_2()
Scopo: Permette la modifica del' ora dell'rtc
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/  
void en_MENU_1_4_1_1(){

   if (lcd_setup_hour()==1){   // controlla se si cambia l'ora ed esegue i cambiamenti
      // aggiorna il display solo se c' stato un cambiamento dell'ora
      lcd_gotoxy(6,1);
      scrivi_num(setup.hh,ZERO); //ora, antempone uno '0' se il numero  < di 10  
      lcd_putc(":");
      scrivi_num(setup.mm,ZERO); //min
   }
   if (p_valido==SET){
      p_valido=NESSUNO;
      orologio_step=MINUTI; //ripristina per la prossima esecuzione di lcd_rtc_setup_hour()
      pag_set_limit(L1_4_1_LIMITE,MENU_ESCI_N);         
      lev.L_1_4_1_1=NO;
      
      lcd_selez_orologio_canc();//clean '>' and '<' around hh:mm
      if( validate_hour(0,setup.mm,setup.hh)==1){
         rtc_set_hour(0,setup.mm,setup.hh);
         rtc.hh=setup.hh;
         rtc.mm=setup.mm;
         rtc.ss=0;
       }
       //TODO: else write not valid @lcd
   } 
}

/*
Funzione: void en_MENU_1_4_1()
Scopo: Menu di Setup ora/data/memoria
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/  
void en_MENU_1_4_1(){
   menu_scorri(141);
   if (p_valido==SET){ 
      p_valido=NESSUNO;
      if (pag>0){
         switch(pag){           
            case 1:            // Ora         
               lev.L_1_4_1_1=SI;    
               pag_set_limit(L1_4_1_1_LIMITE,MENU_ESCI_N); 
               lcd_selez_minuti();
               setup.hh=rtc.hh;
               setup.mm=rtc.mm;
               break;
            case 2:           // data
               lev.L_1_4_1_2=SI; 
               pag_set_limit(L1_4_1_2_LIMITE,MENU_ESCI_N);  
               lcd_selez_day();
               setup.day=rtc.day;
               setup.mth=rtc.mth;
               setup.yy=rtc.yy;
               break;
            case 3:           //Mem.
               lev.L_1_4_1_3=SI; 
               pag_set_limit(L1_4_1_3_LIMITE,MENU_ESCI_N);  
               lcd_selez_day();
               setup.day=ee_get_day();
               setup.mth=ee_get_mth();
               setup.yy=ee_get_yy();
               break;      
            case 4:           // Esci
               lev.L_1_4_1=NO; 
               pag_set_limit(L1_4_LIMITE,MENU_ESCI_Y);
               lcd_putc("\fMENU 1_4"); 
               break;    
         }
      }
   }
   else if (pag==1) {// scrive l'ora attuale 
      lcd_gotoxy(6,1);
      scrivi_num(rtc.hh,ZERO); //ora, antempone uno '0' se il numero  < di 10  
      lcd_putc(":");
      scrivi_num(rtc.mm,ZERO); //min
   }
   else if (pag==2){// scrive la data 
      rtc_read_date();
      lcd_gotoxy(7,1);
      scrivi_num(rtc.day,ZERO);
      lcd_putc("/ ");
      scrivi_num(rtc.mth,ZERO);                
      lcd_putc("/ ");
      scrivi_num(rtc.yy,ZERO);  
   }
   else if (pag==3) {// scrive la data 
      rtc_read_date();
      lcd_gotoxy(7,1);
      scrivi_num(ee_get_day(),ZERO);
      lcd_putc("/ ");
      scrivi_num(ee_get_mth(),ZERO);                
      lcd_putc("/ ");
      scrivi_num(ee_get_yy(),ZERO);  
   }
}   
/*
Funzione: void en_MENU_1_4()
Scopo: Menu di Setup 
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1_4(){
   menu_scorri(14);
   if (p_valido==SET){ 
      p_valido=NESSUNO;
      switch(pag){
         case 1:            // Ora/data                                                                   
            lev.L_1_4_1=SI;  
            pag_set_limit(L1_4_1_LIMITE,MENU_ESCI_Y);  
            lcd_putc("\fMENU 1_4_1");
            break;
         case 2:           // Backlight
            lev.L_1_4_2=SI; 
            pag_set_limit(L1_4_2_LIMITE,MENU_ESCI_Y);  
            lcd_putc("\fMENU 1_4_2");
            break;
         case 3:           //Buzzer
            lev.L_1_4_3=SI;   
            pag_set_limit(L1_4_3_LIMITE,MENU_ESCI_Y);  
            lcd_putc("\fMENU 1_4_3");
            break;      
         case 4:           //Sensore_luce_opz
            lev.L_1_4_4=SI;  
            pag_set_limit(L1_4_4_LIMITE,MENU_ESCI_Y);  
            lcd_putc("\fMENU 1_4_4");
            break;      
         case 5:           // Esci
            lev.L_1_4=NO; 
            pag_set_limit(L1_LIMITE,MENU_ESCI_Y);         
            lcd_putc("\fMENU 1"); 
            break;      
      }
   } 
}

/*
Funzione: void en_MENU_1()
Scopo: Menu principale 
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_1(){
   menu_scorri(1); // controlla Pag giu e su
   if (p_valido==SET){  //conferma
      p_valido=NESSUNO;
      switch(pag){// blokki case eseguiti solo una volta, poi li salter grazie al goto in testa al livello
         case 1:           //Temperatura
            lev.L_1_1=SI;
            lcd_putc("\fMENU 1_1");
            pag_set_limit(L1_1_LIMITE,MENU_ESCI_Y); 
            break;               
         case 2:           //Umidit
            lev.L_1_2=SI;
            lcd_putc("\fMENU 1_2");
            pag_set_limit(L1_2_LIMITE,MENU_ESCI_Y); 
            break;
         case 3:           //Orologio
            lev.L_1_3=SI;
            lcd_putc("\fMENU 1_3");
            pag_set_limit(L1_3_LIMITE,MENU_ESCI_Y); 
            break;
          case 4:          //Setup
            lev.L_1_4=SI;
            lcd_putc("\fMENU 1_4");
            pag_set_limit(L1_4_LIMITE,MENU_ESCI_Y);        
            break; 
         case 5:           // Esci
            lev.L_1=NO;               
            lev.L_0=SI;
            screen_attivo=DATI; // riabilita refresch dati dello stand by
            en_L0_REFRESH_1(); // esce dal menu e deve rivisualizzare i dati dello stand by con scritte e valori
            break; 
      }
   }    
}  
   
/*********************************************   

         GESTIONE LIVELLI DEL MENU
         
**********************************************/


/*
Funzione: void en_MENU()
Scopo: Mostra la schermata di menu attiva
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU(){
      if (lev.L_1==SI){
            screen_attivo=NESSUNO;            //ferma aggiornamento delle schermate di stand-by
            goto L1;
      } 
       // altrimenti sar attivo lev.L_1==SI        
L0:  // cambio dati standby      
      
      if (p_valido==GIU){ 
         en_L0();
L0_REFRESH:  
        en_L0_REFRESH_1();
      }                                                                            
      else if (p_valido==SET) en_L0_REFRESH_2();

      goto FINEMENU; // nel livello 1 ci va nel giro sucessivo.
L1:      
      // controlla se deve entrare nel sottomenu                    
      if (lev.L_1_1==SI){           
         if(lev.L_1_1_1==SI){             // -inc/dec soglia di Tmin       
            if  (lev.L_1_1_1_1==SI){      // -sceglie presa            
               if  (lev.L_1_1_1_1_1==SI){ // -cambio parametri on/off/??
MENU_1_1_1_1_1:   
                  en_MENU_1_1_1_1_1();
                  goto FINEMENU;
               }    
MENU_1_1_1_1:      
               en_MENU_1_1_1_1();
               goto FINEMENU;               
            }
            // else deve ancora impostare la soglia di t max           
MENU_1_1_1:                                         
            en_MENU_1_1_1();
            goto FINEMENU;          
         } 
         else if(lev.L_1_1_2==SI){   // inc/dec soglia di Tmax
            if  (lev.L_1_1_2_1==SI){ // sceglie presa            
               if  (lev.L_1_1_2_1_1==SI){ // cambio parametri on/off/??
MENU_1_1_2_1_1:                  
                  en_MENU_1_1_2_1_1();
                  goto FINEMENU;
               }
MENU_1_1_2_1:
               en_MENU_1_1_2_1();
               goto FINEMENU;               
            }
            // else deve ancora impostare la soglia di t max           
MENU_1_1_2:                                           
            en_MENU_1_1_2();
            goto FINEMENU;          
         }                                                              
         else if(lev.L_1_1_3==SI){   // Tcomp               
            if  (lev.L_1_1_3_1==SI){ // cambio parametri on/off/??
MENU_1_1_3_1:                                                           
               en_MENU_1_1_3_1();
               goto FINEMENU;
            }
            else if ((Tmin.valido==true) && (Tmax.valido==true)){ // se soglie impostate
               if(Tmin.valore==Tmax.valore){              
                  if(scritta_mostrata==NO){                       
                     lcd_putc("\fSoglie identiche");
                     scritta_mostrata=SI;
                  } 
                  else if (p_valido==SET){ 
                     p_valido=NESSUNO;
                     scritta_mostrata=NO;
                     pag=0;
                     lcd_putc("\fMENU 1_1"); 
                     lev.L_1_1_3=NO;
                  }
                  goto FINEMENU;
               } 
               else if(scritta_mostrata==NO){
                  scritta_mostrata=SI; 
                  lcd_putc("\fMENU 1_1_3");
                  pag_set_limit(L1_1_3_LIMITE,MENU_ESCI_Y);
               }                       
MENU_1_1_3:
               en_MENU_1_1_3();
               goto FINEMENU;               
            }                   
            else{  
               if(scritta_mostrata==NO){                       
                  lcd_putc("\fImpostare soglie");
                  scritta_mostrata=SI;
               }
               else if (p_valido==SET){ 
                  p_valido=NESSUNO;
                  scritta_mostrata=NO;
                  pag=0;
                  lcd_putc("\fMENU 1_1"); 
                  lev.L_1_1_3=NO;
               }
            } 
            goto FINEMENU;
         }
         // else nessun sotto menu
           
MENU_1_1:
         en_MENU_1_1(); 
         goto FINEMENU;   
      }                    
      else if (lev.L_1_2==SI){
         if(lev.L_1_2_1==SI){             // -inc/dec soglia di Tmin       
            if  (lev.L_1_2_1_1==SI){      // -sceglie presa            
               if  (lev.L_1_2_1_1_1==SI){ // -cambio parametri on/off/??
MENU_1_2_1_1_1:                             
                  en_MENU_1_2_1_1_1();
                  goto FINEMENU;
               }    
MENU_1_2_1_1:      
               en_MENU_1_2_1_1();                
               goto FINEMENU;               
            }
            // else deve ancora impostare la soglia di t max           
MENU_1_2_1:                    
            en_MENU_1_2_1();
            goto FINEMENU;          
         }   
         else if(lev.L_1_2_2==SI){   // inc/dec soglia di Tmax
            if  (lev.L_1_2_2_1==SI){ // sceglie presa            
               if  (lev.L_1_2_2_1_1==SI){ // cambio parametri on/off/??
MENU_1_2_2_1_1:                  
                  en_MENU_1_2_2_1_1();
                  //goto FINEMENU;
               }
               else
               //else mostra menu
MENU_1_2_2_1:   
                  en_MENU_1_2_2_1();
                  //goto FINEMENU;               
            }
            else
            // else deve ancora impostare la soglia di RH max           
MENU_1_2_2:                                           
               en_MENU_1_2_2();
               //goto FINEMENU;          
         }                                                              
         else if(lev.L_1_2_3==SI){   // Tcomp               
            if  (lev.L_1_2_3_1==SI){ // cambio parametri on/off/??
MENU_1_2_3_1:                                                           
               en_MENU_1_2_3_1();
               //goto FINEMENU;
            }
            else if ((RHmin.valido==SI) && (RHmax.valido==SI)){ // se soglie impostate
               if(RHmin.valore==RHmax.valore){  
                  if(scritta_mostrata==NO){   
                     lcd_putc("\fSoglie identiche");
                     scritta_mostrata=SI;
                  }
                  else if (p_valido==SET){ 
                     p_valido=NESSUNO;
                     scritta_mostrata=NO;
                     pag=0;
                     lcd_putc("\fMENU 1_2"); 
                     lev.L_1_2_3=NO;
                  }
                  //goto FINEMENU;
               }                            
               else if(scritta_mostrata==NO){
                  scritta_mostrata=SI;
                  lcd_putc("\fMENU 1_2_3");               
                  pag_set_limit(L1_2_3_LIMITE,MENU_ESCI_Y);
               } 
               else
MENU_1_2_3:        
                  en_MENU_1_2_3();
                  //goto FINEMENU;               
            }                   
            else{             
               if(scritta_mostrata==NO){   
                  lcd_putc("\fImpostare soglie");
                  scritta_mostrata=SI;
               }
               else if (p_valido==SET){ 
                  p_valido=NESSUNO;
                  scritta_mostrata=NO;
                  pag=0;
                  lcd_putc("\fMENU 1_2"); 
                  lev.L_1_2_3=NO;
               }
               //goto FINEMENU;
            }
            //goto FINEMENU;
         } 
         else 
MENU_1_2:
            en_MENU_1_2();             
            //goto FINEMENU;   
      }                       
      else if (lev.L_1_3==SI){    
         if(lev.L_1_3_1==SI){ // MODE 1
            if(lev.L_1_3_1_1==SI){ // ""cambio orari di on e off""           
               if(lev.L_1_3_1_1_1==SI){ // ON ALLE XX:XX         
MENU_1_3_1_1_1:                    
                  en_MENU_1_3_1_1_1();
                  //goto FINEMENU;
               } 
               else
MENU_1_3_1_1:   
                  en_MENU_1_3_1_1();
                  //goto FINEMENU;                
            } 
            else
            // else fine sottomenu
MENU_1_3_1:
               en_MENU_1_3_1();                            
               //goto FINEMENU;
         }                    
         else if (lev.L_1_3_2==SI){ // MODE 2 
            if (lev.L_1_3_2_1pre==SI){ 
               if (p_valido==GIU){
                  lev.L_1_3_2_1pre=NO;
                  lev.L_1_3_2_1=SI;
                  pag_set_limit(L1_3_2_1_LIMITE,MENU_ESCI_Y);                
                  
                  lcd_putc("\f");
                  lcd_gotoxy(10,1);
                  lcd_putc("<");
               }
            }
            if(lev.L_1_3_2_1==SI){  // sfoglio orario
               if(lev.L_1_3_2_1_1==SI){               
MENU_1_3_2_1_1:        
                  en_MENU_1_3_2_1_1();
                  // da sistemare in livello sucessivo?  
                  //goto FINEMENU;                 
               }
               else
MENU_1_3_2_1:   
                  en_MENU_1_3_2_1();//goto FINEMENU;
            }
            else // fine sottomenu                            
MENU_1_3_2:
               en_MENU_1_3_2();//goto FINEMENU;          
         }
         else
MENU_1_3:
           en_MENU_1_3(); //goto FINEMENU;   
      }
      else if (lev.L_1_4==SI){        
         if(lev.L_1_4_1==SI){             // Ora/DATA  
            if(lev.L_1_4_1_3==SI){       // SETUP DATA salvata in eeprom - mostra salvata
MENU_1_4_1_3: 
               en_MENU_1_4_1_3();
            }
            else if(lev.L_1_4_1_2==SI){       // SETUP DATA - mostra attuale
MENU_1_4_1_2:          
               en_MENU_1_4_1_2();//inc/dec >dd/ mm/ yy< //goto FINEMENU;  
            } 
            else if(lev.L_1_4_1_1==SI){  // SETUP ORA - mostra attuale
MENU_1_4_1_1:          
               en_MENU_1_4_1_1();//inc/dec >hh:mm< //goto FINEMENU; 
            }   
            else{
MENU_1_4_1:
               en_MENU_1_4_1();  // Setup -> Ora/DATA //goto FINEMENU;          
            }
         }
         else 
MENU_1_4:         
           en_MENU_1_4();       // voci del menu Setup //goto FINEMENU;
      }  
      else  
MENU_1:   
        en_MENU_1(); //NESSUN un sottomenu, siamo nel livello 1
      
FINEMENU:
#ASM
nop
#ENDASM    
}


/*********************************************   

         GESTIONE STANDBY DEL MENU
         
**********************************************/

#define WAIT_4_SENSOR 8
/*
Funzione: void en_MENU()
Scopo: Mostra la schermata di standy scelta
Ritorna: -
Parametri: 
Revisione: 1
Note: -
*/ 
void en_MENU_SCREEN_ATTIVO(){
   static int i=0;
   if(screen_attivo!=NESSUNO){ // refresh ora / t & rh   
      lcd_gotoxy(1,1);
      if (screen_attivo==DATI) {
         if (i==0) {
            en_MENU_0_1();//dati
            i=WAIT_4_SENSOR;
         }
         else i--;
      }
      else  en_MENU_0_2();
   }         
}
