/*****************************

	menu_frasi.c

Rilasciato con licenza GNU GPL
	
******************************/

// modalit di visualizazzione se il numero  minore di 10
#define ZERO   1     // mette uno zero          
#define SPAZIO 0     // mette uno spazio                
#define NOSPAZIO 2   // numeri senza spazio   
           
 
void lcd_esci();
void scrivi_num(int x, int mode=SPAZIO);
void lcd_salvato();
void presa_azione(int azione);
int presa_parametro_get(int azione);
void temp_soglia_get();
void temp_soglia_get();
 
 
/*
Funzione: void lcd_esci()
Scopo: Scrive la frase "Esci"
Ritorna: -
Parametri: -
Revisione: 1
Note: -
*/ 
void lcd_esci(){lcd_putc("Esci"); }     
 
/*
Funzione: void scrivi_num(int x, int mode=SPAZIO)
Scopo: Formatta la scrittura di numeri
Ritorna: -
Parametri: -
Revisione: 1
Note: 
*/  
void scrivi_num(int x, int mode=SPAZIO){
   if (x==0){ 
      if (mode==SPAZIO)  lcd_putc(" 0"); 
      else if (mode==NOSPAZIO)  lcd_putc("0"); 
      
      else               lcd_putc("00");
   } 
   else { 
      if (x<10) {  
         if (mode==SPAZIO)          lcd_putc(" ");    
         else if (mode==NOSPAZIO)   goto SKIP; 
         else                       lcd_putc("0");            
      }    
SKIP:
      printf(lcd_putc,"%u",x); // risultato in fr_num;
   }        
}

/*
Funzione: void lcd_salvato()
Scopo: Notifica il salvataggio del dato
Ritorna: -
Parametri: -
Revisione: 1
Note: 
*/  
void lcd_salvato(){
   delay_ms(DELAY_COMPARSA_MENU);
   lcd_gotoxy(2,2);
   lcd_putc("SALVATO");
   delay_ms(DELAY_COMPARSA_MENU);
   lcd_gotoxy(2,2);
   lcd_putc("       ");
} 

                                      
/*--------------------
     routine x prese
---------------------*/

/*
Funzione: void presa_azione(int azione)
Scopo: Scrive l'azione per la presa passata
Ritorna: -
Parametri: 
	int azione: costante 0..2 per indicare la parola da scrivere
Revisione: 1
Note: 
*/  
void presa_azione(int azione){
   lcd_putc(presa_state[azione][0]);//  [tipo di frase(1-3)][carattere]
   lcd_putc(presa_state[azione][1]);   
   lcd_putc(presa_state[azione][2]);       
   
   lcd_putc("\b\b\b");
}      

/*
Funzione: int presa_parametro_get(int azione)
Scopo: Cambia l'azione della presa tra On/Off e ??
Ritorna: 
	int la nuova azione
Parametri: 
	int azione: costante 0..2 per indicare l'azione attualmente passata
Revisione: 1
Note: - 
*/  
int presa_parametro_get(int azione){
    
   if (p_valido==DX){          // incremento
      p_valido=NESSUNO;      
      if (azione<2) azione++;
      else          azione=0; 
   }                
   else if (p_valido==SX){    // decremento
      p_valido=NESSUNO;
      if (azione>0) azione--;
      else          azione=2; 
   } 
   else goto SKIP;   
   presa_azione(azione);    //altrimenti scrive                 
   
SKIP: 
  return azione;
 }                  
 
/*
Funzione: void temp_soglia_get()
Scopo: Inc/decrementa il valore della soglia da SOGLIA_MIN a SOGLIA_MAX
Ritorna: -
Parametri: -
Revisione: 1
Note: Compie le azioni sul valore temporaneo per non modificare quello attuale. 
        Il valore temporaneo deve essere validato prima di essere copiato su quello reale
*/   
void temp_soglia_get(){
  if (p_valido==SU){          // incremento
      p_valido=NESSUNO;
      if (temp_soglia.valore<SOGLIA_MAX){ 
         if(temp_soglia.valido==NO){ // Per gestire stato "??"
            temp_soglia.valido=SI;
            temp_soglia.valore=0;//(SOGLIA_MIN-1);
         }                   
         temp_soglia.valore++;
         scrivi_num(temp_soglia.valore);      
         lcd_putc("\b\b");
      }                            
   }
   else if (p_valido==GIU){    // decremento
      p_valido=NESSUNO;
      if (temp_soglia.valore>SOGLIA_MIN){
         temp_soglia.valido=SI;
         temp_soglia.valore--; 
         scrivi_num(temp_soglia.valore); 
         lcd_putc("\b\b");
      } 
      else{                
         lcd_putc("??");   
         temp_soglia.valido=NO;          
         temp_soglia.valore=0;//(SOGLIA_MIN-1);  // cosi quando si clicca x aumentarlo va al valore corretto altrimenti andava al valore +1                                                                                                                                
         lcd_putc("\b\b");
      }    
   }      
}      

/*
Funzione: void lcd_err(){
Scopo: Scrive la parola "ERRORE"
Ritorna: -
Parametri: -
Revisione: 1
Note: Funzione usata per debug del programma
*/        
void lcd_err(){
   lcd_gotoxy(2,2);
   lcd_putc("ERRORE");
   DELAY_MS(5000);
}


